SystemOrganization addCategory: #'MC2-Core-Announcements'!
SystemOrganization addCategory: #'MC2-Core-Domain'!
SystemOrganization addCategory: #'MC2-Core-Environment'!
SystemOrganization addCategory: #'MC2-Core-Fakes'!
SystemOrganization addCategory: #'MC2-Core-Kernel'!
SystemOrganization addCategory: #'MC2-Core-Repositories'!
SystemOrganization addCategory: #'MC2-Core-Serialization'!
SystemOrganization addCategory: #'MC2-Core-Slices'!
SystemOrganization addCategory: #'MC2-Core-Utilities'!
SystemOrganization addCategory: #'MC2-Core-Versions'!

!String methodsFor: '*mc2-core' stamp: 'cwp 11/20/2008 19:18'!
mdSerializeWith: aMarshal 
	aMarshal writeString: self! !

GRNotification subclass: #MDNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Kernel'!

MDNotification subclass: #MDCommentRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Kernel'!

!MDCommentRequest methodsFor: 'defaults' stamp: 'cwp 12/27/2007 21:36'!
defaultAction
	^ self resume: nil! !

MDNotification subclass: #MDMergeRequest
	instanceVariableNames: 'merges workspace'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Utilities'!

!MDMergeRequest class methodsFor: 'signalling' stamp: 'jf 9/8/2009 16:32'!
includeAll: versions in: aWorkspace
	| merges |
	merges := versions
				collect: [:ea | MDMerge toInclude: ea in: aWorkspace]
				thenSelect: [:ea | ea isNoOp not].
	^ self new
		merges: merges;
		workspace: aWorkspace;
		signal! !

!MDMergeRequest methodsFor: 'accessing' stamp: 'cwp 3/25/2005 21:23'!
merges
	^ merges! !

!MDMergeRequest methodsFor: 'accessing' stamp: 'dc 6/14/2007 10:17'!
merges: aCollection
	merges := aCollection! !

!MDMergeRequest methodsFor: 'accessing' stamp: 'jf 9/8/2009 16:31'!
workspace
	^ workspace! !

!MDMergeRequest methodsFor: 'accessing' stamp: 'jf 9/8/2009 16:31'!
workspace: aWorkspace 
	workspace := aWorkspace! !

MDNotification subclass: #MDTextRequest
	instanceVariableNames: 'prompt template'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Kernel'!

!MDTextRequest class methodsFor: 'as yet unclassified' stamp: 'cwp 11/29/2009 09:47'!
prompt: pString template: tString
	^ (self basicNew initializeWithPrompt: pString template: tString) signal! !

!MDTextRequest methodsFor: 'as yet unclassified' stamp: 'cwp 11/29/2009 09:46'!
defaultAction
	^ MDPlatform current 
		prompt: self prompt 
		template: self template! !

!MDTextRequest methodsFor: 'as yet unclassified' stamp: 'cwp 11/29/2009 09:47'!
initializeWithPrompt: pString template: tString
	self initialize.
	prompt := pString.
	template := tString.! !

!MDTextRequest methodsFor: 'as yet unclassified' stamp: 'cwp 11/29/2009 09:46'!
prompt
	^ prompt! !

!MDTextRequest methodsFor: 'as yet unclassified' stamp: 'cwp 11/29/2009 09:46'!
template
	^ template! !

!Class methodsFor: '*mc2-core-serialization' stamp: 'cwp 11/20/2008 19:18'!
mdSerializeWith: aSerializer 
	aSerializer serializeClass: self! !

!MethodReference methodsFor: '*mc2-core' stamp: 'cwp 3/3/2005 02:15'!
asElement
	^ MDMethodElement 
		className: classSymbol 
		selector: methodSymbol
		classIsMeta: classIsMeta! !

!Symbol methodsFor: '*mc2-core' stamp: 'cwp 11/20/2008 19:18'!
mdSerializeWith: aSerializer 
	aSerializer serializeSymbol: self! !

!ByteString methodsFor: '*mc2-core' stamp: 'cwp 11/20/2008 19:18'!
mdSerializeWith: aSerializer 
	aSerializer serializeUtf8String: self! !

GRObject subclass: #MDObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Kernel'!

MDObject subclass: #MDAdaptor
	instanceVariableNames: 'element'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Domain'!

!MDAdaptor class methodsFor: 'instance creation' stamp: 'jf 1/19/2010 22:54'!
forElement: anElement
	^ self basicNew
		initializeWithElement: anElement;
		yourself! !

!MDAdaptor class methodsFor: 'instance creation' stamp: 'jf 1/19/2010 22:54'!
new
	self shouldNotImplement! !

!MDAdaptor methodsFor: 'initialization' stamp: 'jf 1/19/2010 22:40'!
initializeWithElement: anElement
	self initialize.
	element := anElement! !

!MDAdaptor methodsFor: 'public' stamp: 'jf 1/19/2010 22:36'!
isLoadable: properties
	self subclassResponsibility! !

!MDAdaptor methodsFor: 'public' stamp: 'jf 1/19/2010 22:36'!
isPresent
	self subclassResponsibility! !

!MDAdaptor methodsFor: 'public' stamp: 'jf 1/19/2010 22:36'!
isUpToDate: properties
	self subclassResponsibility ! !

!MDAdaptor methodsFor: 'public' stamp: 'jf 1/19/2010 22:36'!
load: properties
	self subclassResponsibility! !

!MDAdaptor methodsFor: 'public' stamp: 'jf 1/19/2010 22:36'!
merge: properties into: otherProperties onFailure: aBlock
	self subclassResponsibility! !

!MDAdaptor methodsFor: 'public' stamp: 'jf 1/19/2010 22:36'!
remove
	self subclassResponsibility ! !

!MDAdaptor methodsFor: 'public' stamp: 'jf 1/19/2010 22:36'!
update: properties
	self subclassResponsibility! !

MDAdaptor subclass: #MDFakeElementAdaptor
	instanceVariableNames: 'domain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Fakes'!

!MDFakeElementAdaptor class methodsFor: 'instance creation' stamp: 'jf 1/19/2010 22:56'!
forElement: anElement
	^ self forElement: anElement inDomain: MDFakeDomain default! !

!MDFakeElementAdaptor class methodsFor: 'instance creation' stamp: 'jf 1/19/2010 22:56'!
forElement: anElement inDomain: aFakeDomain
	^ self basicNew
		initializeWithDomain: aFakeDomain element: anElement;
		yourself! !

!MDFakeElementAdaptor class methodsFor: 'instance creation' stamp: 'jf 11/8/2009 17:31'!
new
	self shouldNotImplement! !

!MDFakeElementAdaptor methodsFor: 'private' stamp: 'cwp 2/13/2005 19:29'!
checkDependencies
	self isLoadable ifFalse: [self error: 'Unmet dependency']! !

!MDFakeElementAdaptor methodsFor: 'public' stamp: 'cwp 5/24/2005 07:54'!
display: properties
	^ properties one asString! !

!MDFakeElementAdaptor methodsFor: 'initialize-release' stamp: 'jf 1/19/2010 22:40'!
initializeWithDomain: aFakeDomain element: anElement 
	self initializeWithElement: anElement.
	domain := aFakeDomain! !

!MDFakeElementAdaptor methodsFor: 'private' stamp: 'jf 11/8/2009 17:17'!
isLoadable
	| required |
	(element name includes: $/) ifFalse: [ ^ true ].
	required := element name copyUpTo: $/.
	^ domain elements anySatisfy: [ :ea | ea name = required ]! !

!MDFakeElementAdaptor methodsFor: 'public' stamp: 'cwp 2/13/2005 19:44'!
isLoadable: properties
	^ self isLoadable! !

!MDFakeElementAdaptor methodsFor: 'public' stamp: 'jf 11/8/2009 17:17'!
isPresent
	^ (domain 
		at: element
		ifAbsent: [ ^ false ]) notNil! !

!MDFakeElementAdaptor methodsFor: 'public' stamp: 'cwp 2/4/2005 00:39'!
isUpToDate: properties
	properties keysAndValuesDo: 
		[:key :value |
		(self properties at: key ifAbsent: [^ false]) = value ifFalse: [^ false]].
	^ true
	! !

!MDFakeElementAdaptor methodsFor: 'public' stamp: 'cwp 3/25/2005 22:03'!
load: properties 
	self checkDependencies.
	self properties.
	properties keysAndValuesDo: [:key :value | self properties at: key put: value]! !

!MDFakeElementAdaptor methodsFor: 'public' stamp: 'avi 3/16/2005 12:33'!
merge: aPropertyDictionary into: otherPropertyDictionary onFailure: aBlock
	^ aBlock value! !

!MDFakeElementAdaptor methodsFor: 'accessing' stamp: 'jf 11/8/2009 17:17'!
properties
	^ domain at: element! !

!MDFakeElementAdaptor methodsFor: 'public' stamp: 'jf 11/8/2009 17:17'!
remove
	domain 
		at: element
		put: nil! !

!MDFakeElementAdaptor methodsFor: 'public' stamp: 'cwp 2/4/2005 00:33'!
update: properties
	self properties keysAndValuesDo: [:key :value | properties at: key put: value]! !

MDObject subclass: #MDAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Announcements'!

!MDAnnouncement class methodsFor: 'converting' stamp: 'cwp 11/1/2009 23:14'!
asAnnouncement
	^ self new! !

!MDAnnouncement methodsFor: 'converting' stamp: 'cwp 11/1/2009 23:14'!
asAnnouncement
	^ self! !

MDAnnouncement subclass: #MDElementChange
	instanceVariableNames: 'element'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Announcements'!

MDElementChange subclass: #MDElementAdded
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Announcements'!

!MDElementChange class methodsFor: 'instance creation' stamp: 'jf 11/8/2009 16:49'!
for: anElement
	^ self basicNew
		initializeWithElement: anElement;
		yourself! !

!MDElementChange class methodsFor: 'instance creation' stamp: 'jf 11/8/2009 16:56'!
new
	self shouldNotImplement! !

!MDElementChange methodsFor: 'accessing' stamp: 'cwp 7/28/2008 07:26'!
element
	^ element! !

!MDElementChange methodsFor: 'initialization' stamp: 'jf 11/8/2009 16:48'!
initializeWithElement: anElement
	self initialize.
	element := anElement! !

MDElementChange subclass: #MDElementModified
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Announcements'!

MDElementChange subclass: #MDElementRemoved
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Announcements'!

MDAnnouncement subclass: #MDEnvironmentChangeAnnouncement
	instanceVariableNames: 'environment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Announcements'!

!MDEnvironmentChangeAnnouncement class methodsFor: 'instance creation' stamp: 'jf 11/25/2009 14:15'!
new
	self shouldNotImplement! !

!MDEnvironmentChangeAnnouncement methodsFor: 'accessing' stamp: 'jf 11/25/2009 14:13'!
environment
	^ environment! !

!MDEnvironmentChangeAnnouncement methodsFor: 'accessing' stamp: 'jf 11/25/2009 14:40'!
environment: anEnvironment
	environment := anEnvironment! !

!MDEnvironmentChangeAnnouncement methodsFor: 'initialization' stamp: 'jf 11/25/2009 14:11'!
initializeWithEnvironment: anEnvironment
	self initialize.
	environment := anEnvironment! !

MDEnvironmentChangeAnnouncement subclass: #MDEnvironmentProjectAnnouncement
	instanceVariableNames: 'project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Announcements'!

!MDEnvironmentProjectAnnouncement class methodsFor: 'instance creation' stamp: 'jf 11/25/2009 14:33'!
environment: anEnvironment project: aProject
	^ self basicNew
		initializeWithEnvironment: anEnvironment project: aProject;
		yourself! !

!MDEnvironmentProjectAnnouncement methodsFor: 'initialization' stamp: 'jf 11/25/2009 14:33'!
initializeWithEnvironment: anEnvironment project: aProject
	self initializeWithEnvironment: anEnvironment.
	project := aProject! !

!MDEnvironmentProjectAnnouncement methodsFor: 'accessing' stamp: 'jf 11/25/2009 14:32'!
project
	^ project! !

MDEnvironmentProjectAnnouncement subclass: #MDProjectRemoved
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Announcements'!

MDEnvironmentChangeAnnouncement subclass: #MDEnvironmentRepositoryAnnouncement
	instanceVariableNames: 'repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Announcements'!

!MDEnvironmentRepositoryAnnouncement class methodsFor: 'instance creation' stamp: 'jf 11/25/2009 14:20'!
environment: anEnvironment repository: aRepository
	^ self basicNew
		initializeWithEnvironment: anEnvironment repository: aRepository;
		yourself! !

!MDEnvironmentRepositoryAnnouncement methodsFor: 'initialization' stamp: 'jf 11/25/2009 14:19'!
initializeWithEnvironment: anEnvironment repository: aRepository
	self initializeWithEnvironment: anEnvironment.
	repository := aRepository! !

!MDEnvironmentRepositoryAnnouncement methodsFor: 'accessing' stamp: 'jf 11/25/2009 14:18'!
repository
	^ repository! !

MDEnvironmentRepositoryAnnouncement subclass: #MDRepositoryAdded
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Announcements'!

MDEnvironmentRepositoryAnnouncement subclass: #MDRepositoryRemoved
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Announcements'!

MDEnvironmentChangeAnnouncement subclass: #MDEnvironmentSliceAnnouncement
	instanceVariableNames: 'slice'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Announcements'!

!MDEnvironmentSliceAnnouncement class methodsFor: 'instance creation' stamp: 'jf 11/25/2009 14:14'!
environment: anEnvironment slice: aSlice
	^ self basicNew
		initializeWithEnvironment: anEnvironment slice: aSlice;
		yourself! !

!MDEnvironmentSliceAnnouncement methodsFor: 'initialization' stamp: 'jf 11/25/2009 14:13'!
initializeWithEnvironment: anEnvironment slice: aSlice
	self initializeWithEnvironment: anEnvironment.
	slice := aSlice! !

!MDEnvironmentSliceAnnouncement methodsFor: 'accessing' stamp: 'jf 11/25/2009 14:05'!
slice
	^ slice! !

MDEnvironmentSliceAnnouncement subclass: #MDSliceAdded
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Announcements'!

MDEnvironmentSliceAnnouncement subclass: #MDSliceRemoved
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Announcements'!

MDEnvironmentSliceAnnouncement subclass: #MDSliceTouched
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Announcements'!

MDSliceTouched subclass: #MDSliceClean
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Announcements'!

MDSliceTouched subclass: #MDSliceDirty
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Announcements'!

!MDSliceTouched class methodsFor: 'as yet unclassified' stamp: 'jf 11/25/2009 15:41'!
slice: aSlice
	"Historians need to signal these and do not have access to their Environment"
	^ self environment: nil slice: aSlice! !

MDAnnouncement subclass: #MDProjectChangeAnnouncement
	instanceVariableNames: 'project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Announcements'!

!MDProjectChangeAnnouncement class methodsFor: 'instance creation' stamp: 'jf 11/25/2009 16:00'!
new
	self shouldNotImplement! !

!MDProjectChangeAnnouncement class methodsFor: 'instance creation' stamp: 'jf 11/25/2009 15:42'!
project: aProject
	^ self basicNew
		initializeWithProject: aProject;
		yourself! !

!MDProjectChangeAnnouncement methodsFor: 'initialization' stamp: 'jf 11/25/2009 15:42'!
initializeWithProject: aProject
	self initialize.
	project := aProject! !

!MDProjectChangeAnnouncement methodsFor: 'accessing' stamp: 'jf 11/25/2009 15:42'!
project
	^ project! !

MDProjectChangeAnnouncement subclass: #MDProjectRenamed
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Announcements'!

MDProjectChangeAnnouncement subclass: #MDProjectRepositoryAnnouncement
	instanceVariableNames: 'repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Announcements'!

!MDProjectRepositoryAnnouncement class methodsFor: 'instance creation' stamp: 'jf 11/25/2009 16:00'!
project: aProject
	self shouldNotImplement! !

!MDProjectRepositoryAnnouncement class methodsFor: 'instance creation' stamp: 'jf 11/25/2009 15:48'!
project: aProject repository: aRepository
	^ self basicNew
		initializeWithProject: aProject repository: aRepository;
		yourself! !

!MDProjectRepositoryAnnouncement methodsFor: 'initialization' stamp: 'jf 11/25/2009 15:47'!
initializeWithProject: aProject repository: aRepository
	self initializeWithProject: aProject.
	repository := aRepository! !

!MDProjectRepositoryAnnouncement methodsFor: 'accessing' stamp: 'jf 11/25/2009 15:47'!
repository
	^ repository! !

MDProjectRepositoryAnnouncement subclass: #MDRepositoryAssociated
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Announcements'!

MDProjectRepositoryAnnouncement subclass: #MDRepositoryDissociated
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Announcements'!

MDProjectChangeAnnouncement subclass: #MDProjectSliceAnnouncement
	instanceVariableNames: 'slice'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Announcements'!

!MDProjectSliceAnnouncement class methodsFor: 'instance creation' stamp: 'jf 11/25/2009 16:01'!
project: aProject
	self shouldNotImplement! !

!MDProjectSliceAnnouncement class methodsFor: 'instance creation' stamp: 'jf 11/25/2009 15:59'!
project: aProject slice: aSlice
	^ self basicNew
		initializeWithProject: aProject slice: aSlice;
		yourself! !

!MDProjectSliceAnnouncement methodsFor: 'initialization' stamp: 'jf 11/25/2009 15:58'!
initializeWithProject: aProject slice: aSlice
	self initializeWithProject: aProject.
	slice := aSlice! !

!MDProjectSliceAnnouncement methodsFor: 'accessing' stamp: 'jf 11/25/2009 15:57'!
slice
	^ slice! !

MDProjectSliceAnnouncement subclass: #MDSliceAssociated
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Announcements'!

MDProjectSliceAnnouncement subclass: #MDSliceDissociated
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Announcements'!

MDObject subclass: #MDChange
	instanceVariableNames: 'version variant'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Utilities'!

!MDChange class methodsFor: 'instance creation' stamp: 'jf 11/8/2009 18:28'!
new
	self shouldNotImplement! !

!MDChange class methodsFor: 'instance creation' stamp: 'jf 11/8/2009 18:28'!
version: aVersion variant: aVariant
	^ self basicNew
		initializeWithVersion: aVersion variant: aVariant;
		yourself! !

!MDChange methodsFor: 'comparing' stamp: 'cwp 5/24/2008 21:45'!
<= other
	^ self element printString <= other element printString! !

!MDChange methodsFor: 'accessing' stamp: 'cwp 5/24/2008 21:43'!
element
	^ variant element! !

!MDChange methodsFor: 'accessing' stamp: 'cwp 5/24/2008 22:18'!
final
	^ variant! !

!MDChange methodsFor: 'testing' stamp: 'cwp 5/24/2008 16:14'!
hasEffect
	^ version variant ~= variant! !

!MDChange methodsFor: 'initialization' stamp: 'jf 11/8/2009 18:27'!
initializeWithVersion: aVersion variant: aVariant
	self initialize.
	version := aVersion.
	variant := aVariant! !

!MDChange methodsFor: 'accessing' stamp: 'cwp 7/26/2008 16:10'!
name
	^ variant properties name ifNil: [self element printString]! !

!MDChange methodsFor: 'accessing' stamp: 'cwp 5/24/2008 22:18'!
original
	^ version variant! !

!MDChange methodsFor: 'accessing' stamp: 'cwp 5/24/2008 15:52'!
variant
	^ variant! !

!MDChange methodsFor: 'accessing' stamp: 'cwp 5/24/2008 15:52'!
version
	^ version
	! !

MDObject subclass: #MDDomain
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Domain'!

!MDDomain commentStamp: 'dc 6/14/2007 05:59' prior: 0!
I am an abstract superclass. I present an interface to a Smalltalk image. I have methods for querying the state of elements in the image and modifying them. My protocol is expressed in terms of Elements and Variants; I know nothing about Versions.

My subclasses must implement an adaption method for each subclass of ImageElement.

This is a facade for the class structures of the image. It presents a protocol for querying the state of the image or modifying it using variants.!

!MDDomain class methodsFor: 'as yet unclassified' stamp: 'cwp 6/15/2008 20:30'!
classForType: aSymbol
	^ self allSubclassesDo: [:ea | ea type = aSymbol ifTrue: [^ ea]]! !

!MDDomain class methodsFor: 'as yet unclassified' stamp: 'jf 11/8/2009 17:34'!
default
	self subclassResponsibility! !

!MDDomain class methodsFor: 'as yet unclassified' stamp: 'cwp 6/15/2008 20:31'!
defaultForType: aSymbol
	| class |
	class := self classForType: aSymbol.
	^ class default! !

!MDDomain class methodsFor: 'as yet unclassified' stamp: 'jf 11/8/2009 17:11'!
type
	self subclassResponsibility! !

!MDDomain methodsFor: 'public' stamp: 'cwp 10/16/2009 22:06'!
adapt: anElement
	self subclassResponsibility! !

!MDDomain methodsFor: 'public' stamp: 'cwp 10/16/2009 22:38'!
hasElement: anElement
	^ (self adapt: anElement) isPresent! !

!MDDomain methodsFor: 'public' stamp: 'cwp 2/4/2006 20:40'!
isLoadable: aVariant 
	^aVariant isLoadableInto: self! !

!MDDomain methodsFor: 'public' stamp: 'cwp 2/4/2006 20:41'!
isUpToDate: aVariant 
	^aVariant isUpToDateFor: self! !

!MDDomain methodsFor: 'public' stamp: 'cwp 10/16/2005 14:16'!
loadVariant: aVariant 
	aVariant loadInto: self! !

!MDDomain methodsFor: 'public' stamp: 'cwp 3/2/2006 18:25'!
transaction: aBlock
	^ aBlock value! !

!MDDomain methodsFor: 'public' stamp: 'cwp 10/16/2005 14:17'!
updateVariant: aVariant 
	^aVariant updateFrom: self! !

MDDomain subclass: #MDFakeDomain
	instanceVariableNames: 'dict'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Fakes'!

!MDFakeDomain class methodsFor: 'instance creation' stamp: 'cwp 8/18/2009 22:18'!
default
	^ self new! !

!MDFakeDomain class methodsFor: 'as yet unclassified' stamp: 'cwp 6/15/2008 20:31'!
type
	^ #fake! !

!MDFakeDomain methodsFor: 'public' stamp: 'jf 11/8/2009 17:16'!
adapt: anElement
	^ MDFakeElementAdaptor forElement: anElement inDomain: self! !

!MDFakeDomain methodsFor: 'accessing' stamp: 'cwp 5/18/2008 20:07'!
allElements
	^ dict keys! !

!MDFakeDomain methodsFor: 'private' stamp: 'cwp 5/11/2008 22:24'!
at: anElement
	(self includesElement: anElement) ifFalse:
		[dict at: anElement put: Dictionary new].
	^ dict at: anElement! !

!MDFakeDomain methodsFor: 'private' stamp: 'cwp 5/11/2008 12:32'!
at: anElement ifAbsent: aBlock
	^ dict at: anElement ifAbsent: aBlock! !

!MDFakeDomain methodsFor: 'private' stamp: 'cwp 11/28/2004 15:25'!
at: anElement put: aPropertyDictionary
	dict at: anElement put: aPropertyDictionary! !

!MDFakeDomain methodsFor: 'accessing' stamp: 'cwp 5/18/2008 20:08'!
elements
	| result |
	result := Set new.
	dict keysAndValuesDo: [ :element :version | version ifNotNil: [ result add: element ] ].
	^ result! !

!MDFakeDomain methodsFor: 'private' stamp: 'cwp 5/11/2008 22:07'!
includesElement: anElement 
	^ (dict at: anElement ifAbsent: [^ false]) notNil! !

!MDFakeDomain methodsFor: 'initialize-release' stamp: 'jf 11/8/2009 17:08'!
initialize
	super initialize.
	dict := Dictionary new! !

!MDFakeDomain methodsFor: 'accessing' stamp: 'cwp 5/26/2008 22:04'!
name
	^ #fake! !

!MDFakeDomain methodsFor: 'private' stamp: 'cwp 5/11/2008 22:02'!
removeElement: anElement
	(dict includesKey: anElement)
		ifTrue: [dict at: anElement put: nil]! !

MDObject subclass: #MDElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Domain'!

!MDElement commentStamp: 'dc 6/14/2007 05:21' prior: 0!
I am an abstract superclass. My subclasses are references to the parts of a Smalltalk program. 

These play the same role as MethodReferences. They are references to specific parts of a Smalltalk program. They're more fine-grained than Definitions in MC1 - you'll see separate elements for each instance variable, for example, so that they can referred to directly, rather than by implication in a class reference.!

!MDElement methodsFor: 'comparing' stamp: 'cwp 5/28/2008 21:43'!
<= other
	^ self printString <= other printString! !

!MDElement methodsFor: 'comparing' stamp: 'avi 11/28/2004 16:02'!
= other
	self subclassResponsibility ! !

!MDElement methodsFor: 'adapting' stamp: 'jf 10/4/2009 20:51'!
adaptedFor: aDomain
	"Visitor pattern. Subclasses should dispatch to an appropriate method on aDomain
	to return an adaptor appropriate for the receiver."
	
	self subclassResponsibility! !

!MDElement methodsFor: 'conflicts' stamp: 'avi 3/16/2005 12:27'!
alwaysPreferDefinition
	^ false! !

!MDElement methodsFor: 'conflicts' stamp: 'avi 3/16/2005 12:27'!
alwaysPreferRemoval
	^ false! !

!MDElement methodsFor: 'printing' stamp: 'cwp 8/28/2005 17:43'!
displayClassName
	^ 'Element'! !

!MDElement methodsFor: 'adapting' stamp: 'jf 10/4/2009 20:53'!
domain
	"Return the domain type that holds the elements of the receiver's type."
	
	self subclassResponsibility! !

!MDElement methodsFor: 'dispatching' stamp: 'cwp 10/16/2009 22:26'!
handleWith: anObject
	self subclassResponsibility! !

!MDElement methodsFor: 'comparing' stamp: 'avi 11/28/2004 16:02'!
hash
	self subclassResponsibility ! !

!MDElement methodsFor: 'domain' stamp: 'cwp 10/16/2009 22:39'!
is: properties upToDateFor: aDomain
	^ (aDomain adapt: self) isUpToDate: properties! !

!MDElement methodsFor: 'domain' stamp: 'cwp 10/16/2009 22:39'!
isLoadable: properties into: aDomain
	^ (aDomain adapt: self) isLoadable: properties
! !

!MDElement methodsFor: 'domain' stamp: 'cwp 10/16/2009 22:40'!
load: properties into: aDomain
	^ (aDomain adapt: self) load: properties
! !

!MDElement methodsFor: 'conflicts' stamp: 'cwp 10/16/2009 22:40'!
merge: aPropertyDictionary into: otherPropertyDictionary in: aDomain onFailure: aBlock
	^ (aDomain adapt: self)
		merge: aPropertyDictionary
		into: otherPropertyDictionary
		onFailure: aBlock! !

!MDElement methodsFor: 'converting' stamp: 'dc 6/21/2007 18:31'!
newDefinitionVariant
	"Creates a new definition variant based on the receiver."
	^ MDDefinitionVariant forElement: self! !

!MDElement methodsFor: 'converting' stamp: 'dc 6/21/2007 18:31'!
newElementVersion
	"Creates a new version based on the receiver."
	^ self newDefinitionVariant newElementVersion ! !

!MDElement methodsFor: 'domain' stamp: 'cwp 10/16/2009 22:40'!
removeFrom: aDomain
	^ (aDomain adapt: self) remove! !

!MDElement methodsFor: 'domain' stamp: 'cwp 10/16/2009 22:40'!
update: properties from: aDomain
	^ (aDomain adapt: self) update: properties! !

MDElement subclass: #MDFakeElement
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Fakes'!

!MDFakeElement class methodsFor: 'instance creation' stamp: 'cwp 2/5/2005 19:02'!
named: aSymbol
	^ self new name: aSymbol! !

!MDFakeElement methodsFor: 'comparing' stamp: 'cwp 2/5/2005 19:27'!
= other
	self species = other species ifFalse: [^ false].
	^ self name = other name! !

!MDFakeElement methodsFor: 'public' stamp: 'jf 10/4/2009 20:21'!
adaptedFor: aDomain 
	^ aDomain adaptorForElement: self! !

!MDFakeElement methodsFor: 'printing' stamp: 'cwp 4/25/2005 04:11'!
displayOn: aStream
	aStream nextPutAll: name! !

!MDFakeElement methodsFor: 'accessing' stamp: 'cwp 5/26/2008 22:00'!
domain
	^ #fake! !

!MDFakeElement methodsFor: 'dispatching' stamp: 'cwp 10/16/2009 22:29'!
handleWith: anObject
	^ anObject handleFake: self! !

!MDFakeElement methodsFor: 'comparing' stamp: 'cwp 2/5/2005 19:27'!
hash
	^ name hash! !

!MDFakeElement methodsFor: 'accessing' stamp: 'cwp 2/5/2005 18:58'!
name
	^ name! !

!MDFakeElement methodsFor: 'accessing' stamp: 'cwp 5/22/2008 00:10'!
name: aSymbol
	name := aSymbol! !

!MDFakeElement methodsFor: 'printing' stamp: 'cwp 11/20/2008 19:05'!
printOn: aStream 
	aStream print: self class.
	aStream nextPut: $<.
	aStream nextPutAll: name.
	aStream nextPut: $>! !

MDObject subclass: #MDElementHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Domain'!

!MDElementHandler methodsFor: 'handling' stamp: 'cwp 10/16/2009 22:18'!
handle: anElement
	^ anElement handleWith: self! !

!MDElementHandler methodsFor: 'handling' stamp: 'cwp 10/16/2009 22:17'!
handleElement: anElement 
	! !

!MDElementHandler methodsFor: 'fakes' stamp: 'cwp 10/16/2009 22:30'!
handleFake: anElement
	^ self handleElement: anElement! !

MDElementHandler subclass: #MDSliceInclusionHandler
	instanceVariableNames: 'slice'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Domain'!

!MDSliceInclusionHandler class methodsFor: 'instance creation' stamp: 'jf 1/8/2010 15:17'!
new
	self shouldNotImplement! !

!MDSliceInclusionHandler class methodsFor: 'instance creation' stamp: 'jf 1/8/2010 15:17'!
on: aSlice
	^ self basicNew
		initializeWithSlice: aSlice;
		yourself! !

!MDSliceInclusionHandler methodsFor: 'handling' stamp: 'cwp 10/16/2009 22:17'!
handleElement: anElement 
	^ false! !

!MDSliceInclusionHandler methodsFor: 'initialize-release' stamp: 'jf 1/8/2010 15:16'!
initializeWithSlice: aSlice
	self initialize.
	slice := aSlice! !

MDObject subclass: #MDEnvironment
	instanceVariableNames: 'announcer workspace store projects historians repositories'
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'MC2-Core-Environment'!

!MDEnvironment class methodsFor: 'as yet unclassified' stamp: 'cwp 8/13/2009 18:23'!
createDefault
	^ self new! !

!MDEnvironment class methodsFor: 'as yet unclassified' stamp: 'cwp 8/13/2009 18:23'!
default
	^ Default ifNil: [Default := self createDefault]! !

!MDEnvironment class methodsFor: 'as yet unclassified' stamp: 'cwp 9/4/2009 15:58'!
forTesting
	^ MDEnvironment new
		addDomain: MDFakeDomain new;
		yourself! !

!MDEnvironment class methodsFor: 'as yet unclassified' stamp: 'cwp 11/25/2009 16:35'!
reset
	Default ifNotNil:
		[Default unsubscribe.
		Default := nil]! !

!MDEnvironment methodsFor: 'children' stamp: 'jf 10/21/2009 16:39'!
addDomain: aDomain 
	^ workspace 
		domainAt: aDomain name
		put: aDomain! !

!MDEnvironment methodsFor: 'children' stamp: 'cwp 11/25/2009 15:08'!
addProject: aProject 
	projects register: aProject.
	self forwardAnnouncementsFrom: aProject.
	^ aProject! !

!MDEnvironment methodsFor: 'children' stamp: 'jf 11/25/2009 14:29'!
addRepository: aRepository
	repositories register: aRepository.
	self announce: (MDRepositoryAdded environment: self repository: aRepository).
	^ aRepository! !

!MDEnvironment methodsFor: 'children' stamp: 'cwp 9/6/2009 11:20'!
addRepository: aRepository toProject: aProject
	(self includesRepositoryId: aRepository id) ifFalse:
		[self addRepository: aRepository].
	aProject addRepository: aRepository! !

!MDEnvironment methodsFor: 'children' stamp: 'cwp 11/25/2009 16:47'!
addSlice: aSlice
	| historian |
	historian := MDHistorian forSlice: aSlice.
	historians register: historian.
	self forwardAnnouncementsFrom: historian.
	self announce: (MDSliceAdded environment: self slice: aSlice).
	^ aSlice! !

!MDEnvironment methodsFor: 'children' stamp: 'cwp 9/6/2009 11:22'!
addSlice: aSlice toProject: aProject
	(self includesSliceId: aSlice id) ifFalse: [self addSlice: aSlice].
	aProject addSlice: aSlice! !

!MDEnvironment methodsFor: 'content' stamp: 'cwp 8/16/2009 15:14'!
allElementsForSlice: aSlice do: aBlock 
	| elements parents snapshot elem memo |
	elements := aSlice elements.
	elements do: aBlock.
	parents := (self 
		historianWithId: aSlice id
		ifAbsent: [ ^ self ]) parents.
	parents isEmpty ifTrue: [ ^ self ].
	memo := (self store get: parents first) ifNil: [ ^ self ].
	snapshot := (self store get: memo reference) ifNil: [ ^ self ].
	(snapshot getVersionsFrom: self store) do: 
		[ :version | 
		elem := version element.
		(elements includes: elem) ifFalse: [ aBlock value: elem ] ]! !

!MDEnvironment methodsFor: 'notifications' stamp: 'cwp 8/14/2009 18:26'!
annElementChanged: announcement
	self noteElementChanged: announcement element! !

!MDEnvironment methodsFor: 'announcing' stamp: 'jf 11/19/2009 16:10'!
announce: anObject
	self announcer announce: anObject! !

!MDEnvironment methodsFor: 'announcing' stamp: 'cwp 11/25/2009 14:47'!
announcer
	^ announcer! !

!MDEnvironment methodsFor: 'content' stamp: 'cwp 8/16/2009 15:14'!
changesForSlice: aSlice 
	| result parents memo snapshot |
	result := Set new.
	parents := (self 
		historianWithId: aSlice id
		ifAbsent: 
			[ ^ #() ]) parents.
	parents isEmpty ifTrue: [ ^ result ].
	memo := (self store get: parents first) ifNil: [ ^ result ].
	snapshot := (self store get: memo reference) ifNil: [ ^ result ].
	(aSlice expandVersions: (snapshot getVersionsFrom: self store)) do: 
		[ :version | 
		self workspace 
			changeFromVersion: version
			do: [ :change | result add: change ] ].
	^ result! !

!MDEnvironment methodsFor: 'accessing' stamp: 'cwp 8/14/2009 09:46'!
environment
	^ self! !

!MDEnvironment methodsFor: 'notifications' stamp: 'cwp 11/25/2009 14:56'!
forwardAnnouncement: anAnnouncement
	self announce: anAnnouncement! !

!MDEnvironment methodsFor: 'children' stamp: 'cwp 11/25/2009 15:08'!
forwardAnnouncementsFrom: anObject 
	anObject announcer 
		observe: MDAnnouncement
		send: #forwardAnnouncement:
		to: self! !

!MDEnvironment methodsFor: 'accessing' stamp: 'cwp 8/16/2009 15:14'!
historianWithId: aHashstamp 
	^ historians objectWithId: aHashstamp! !

!MDEnvironment methodsFor: 'accessing' stamp: 'cwp 8/16/2009 15:14'!
historianWithId: aHashstamp ifAbsent: aBlock 
	^ historians 
		objectWithId: aHashstamp
		ifAbsent: aBlock! !

!MDEnvironment methodsFor: 'children' stamp: 'cwp 8/14/2009 18:18'!
historians
	^ historians ! !

!MDEnvironment methodsFor: 'actions' stamp: 'cwp 8/16/2009 15:14'!
include: aMemo 
	| slice snapshot |
	slice := self sliceWithId: aMemo sliceId.
	snapshot := self store get: aMemo reference.
	
	[ slice 
		include: snapshot
		from: store
		in: workspace ] 
		on: MDMergeRequest
		do: [ :req | MDConflictBrowser handleRequest: req ].
	(self historianWithId: aMemo sliceId) noteInclude: aMemo! !

!MDEnvironment methodsFor: 'children' stamp: 'cwp 8/18/2009 22:11'!
includesProjectId: aHashstamp
	^ projects includesId: aHashstamp! !

!MDEnvironment methodsFor: 'children' stamp: 'cwp 8/18/2009 22:13'!
includesRepositoryId: aHashstamp 
	^ self repositories anySatisfy: [:ea | ea id = aHashstamp]! !

!MDEnvironment methodsFor: 'children' stamp: 'cwp 8/18/2009 22:15'!
includesSliceId: aHashstamp 
	^ self slices anySatisfy: [:ea | ea id = aHashstamp]! !

!MDEnvironment methodsFor: 'initialize-release' stamp: 'cwp 11/25/2009 17:10'!
initialize
	super initialize.
	announcer := MDAnnouncer new.
	workspace := MDWorkspace new.
	store := MDMemoryRepository named: 'store'.
	projects := MDRegistry new.
	historians := MDRegistry new.
	repositories := MDRegistry new.
! !

!MDEnvironment methodsFor: 'notifications' stamp: 'cwp 8/16/2009 15:14'!
isDirty: aSlice 
	^ (self 
		historianWithId: aSlice id
		ifAbsent: [ ^ false ]) isDirty! !

!MDEnvironment methodsFor: 'actions' stamp: 'cwp 8/16/2009 15:14'!
load: aMemo 
	| slice snapshot sliceId |
	sliceId := aMemo sliceId.
	slice := (self sliceWithId: sliceId) ifNil: [ MDExplicitSlice named: 'temporary' ].
	snapshot := self store get: aMemo reference.
	slice 
		load: snapshot
		from: store
		to: workspace.
	(self 
		historianWithId: aMemo sliceId
		ifAbsent: [ ^ self ]) noteLoad: aMemo! !

!MDEnvironment methodsFor: 'notifications' stamp: 'cwp 8/16/2009 15:14'!
noteClean: aSlice 
	^ (self historianWithId: aSlice id) markClean! !

!MDEnvironment methodsFor: 'notifications' stamp: 'cwp 8/16/2009 15:14'!
noteDirty: aSlice 
	^ (self historianWithId: aSlice id) markDirty! !

!MDEnvironment methodsFor: 'notifications' stamp: 'cwp 8/14/2009 22:03'!
noteElementChanged: anElement 
	historians objects do: [ :ea | ea noteElementChanged: anElement ]! !

!MDEnvironment methodsFor: 'children' stamp: 'cwp 8/18/2009 21:59'!
projectWithId: aHashstamp
	^ projects objectWithId: aHashstamp! !

!MDEnvironment methodsFor: 'children' stamp: 'cwp 8/16/2009 15:23'!
projects
	^ projects objects! !

!MDEnvironment methodsFor: 'children' stamp: 'jf 11/25/2009 14:34'!
removeProjectId: aHashstamp 
	| project |
	project := projects unregisterId: aHashstamp ifAbsent: [^ nil].
	self announce: (MDProjectRemoved environment: self project: project).
	^ project! !

!MDEnvironment methodsFor: 'children' stamp: 'jf 11/25/2009 14:31'!
removeRepositoryId: aHashstamp 
	| repository |
	repository := repositories unregisterId: aHashstamp ifAbsent: [^ nil].
	self projects do: [:each | each removeRepository: repository].
	self announce: (MDRepositoryRemoved environment: self repository: repository).
	^ repository! !

!MDEnvironment methodsFor: 'children' stamp: 'jf 11/25/2009 14:31'!
removeSliceId: aHashstamp 
	| slice |
	slice := (historians unregisterId: aHashstamp ifAbsent: [^ nil]) slice.
	self projects do: [:each | each removeSlice: slice].
	self announce: (MDSliceRemoved environment: self slice: slice).
	^ slice! !

!MDEnvironment methodsFor: 'accessing' stamp: 'cwp 9/5/2009 22:00'!
repositories
	^ repositories objects! !

!MDEnvironment methodsFor: 'children' stamp: 'jf 9/8/2009 17:43'!
repositoryWithId: aHashstamp
	^ repositories objectWithId: aHashstamp! !

!MDEnvironment methodsFor: 'actions' stamp: 'cwp 8/16/2009 15:14'!
save: aSlice 
	| memo historian |
	historian := self historianWithId: aSlice id.
	memo := historian memo.
	^ memo ifNotNil: 
		[ aSlice 
			saveFrom: workspace
			to: store
			memo: memo.
		historian noteSave: memo.
		memo ]! !

!MDEnvironment methodsFor: 'accessing' stamp: 'jf 9/6/2009 13:34'!
sliceWithId: sliceId 
	| historian |
	historian := self historianWithId: sliceId.
	^ historian ifNotNil: [historian slice]! !

!MDEnvironment methodsFor: 'children' stamp: 'cwp 8/14/2009 17:57'!
slices
	^ historians objects collect: [:ea | ea slice]! !

!MDEnvironment methodsFor: 'accessing' stamp: 'cwp 8/12/2009 10:24'!
store
	^ store! !

!MDEnvironment methodsFor: 'notifications' stamp: 'jf 11/19/2009 16:09'!
subscribe
	self announcer 
		observe: MDElementChange
		send: #annElementChanged:
		to: self! !

!MDEnvironment methodsFor: 'content' stamp: 'cwp 8/12/2009 17:57'!
unsavedChangesForSlice: aSlice 
	| result |
	result := Set new.
	self 
		allElementsForSlice: aSlice
		do: 
			[ :element | 
			workspace 
				changeForElement: element
				do: [ :change | result add: change ] ].
	^ result! !

!MDEnvironment methodsFor: 'notifications' stamp: 'jf 11/19/2009 16:09'!
unsubscribe
	self announcer unsubscribe: self! !

!MDEnvironment methodsFor: 'accessing' stamp: 'cwp 8/12/2009 10:24'!
workspace
	^ workspace! !

MDObject subclass: #MDHashedObject
	instanceVariableNames: 'hashstamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Versions'!

!MDHashedObject methodsFor: 'comparing' stamp: 'cwp 3/16/2008 00:12'!
= other
	^ self species = other species
		and: [self hashstamp = other hashstamp]! !

!MDHashedObject methodsFor: 'comparing' stamp: 'cwp 8/9/2009 13:57'!
hash
	^ hashstamp hash! !

!MDHashedObject methodsFor: 'accessing' stamp: 'cwp 8/9/2009 13:57'!
hashstamp
	^ hashstamp! !

!MDHashedObject methodsFor: 'initialize-release' stamp: 'cwp 8/9/2009 13:57'!
initHashstamp
	hashstamp := MDHashstamp timestamp: hashstamp! !

!MDHashedObject methodsFor: 'initialize-release' stamp: 'cwp 1/19/2010 20:12'!
initializeWithHashstamp: aHashstamp
	self initialize.
	hashstamp := aHashstamp! !

!MDHashedObject methodsFor: 'testing' stamp: 'cwp 1/19/2007 20:49'!
isMemo
	^ false! !

!MDHashedObject methodsFor: 'testing' stamp: 'cwp 1/1/2007 09:34'!
isSnapshot
	^ false! !

!MDHashedObject methodsFor: 'testing' stamp: 'cwp 11/28/2008 21:47'!
isVersion
	^ false! !

!MDHashedObject methodsFor: 'serialization' stamp: 'cwp 11/20/2008 19:18'!
mdSerializeWith: aSerializer 
	^ aSerializer serializeHashedObject: self! !

!MDHashedObject methodsFor: 'accessing' stamp: 'cwp 8/9/2009 13:57'!
timestamp
	^ hashstamp timestamp! !

MDHashedObject subclass: #MDMemo
	instanceVariableNames: 'reference parents properties sliceId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Versions'!

!MDMemo class methodsFor: 'instance creation' stamp: 'cwp 3/6/2008 19:37'!
new
	^ self parents: Array new properties: MDPropertyDictionary new! !

!MDMemo class methodsFor: 'instance creation' stamp: 'cwp 3/6/2008 19:37'!
parents: anArray
	^ self parents: anArray properties: MDPropertyDictionary new! !

!MDMemo class methodsFor: 'instance creation' stamp: 'cwp 1/19/2010 20:25'!
parents: anArray properties: properties
	^ self basicNew 
		initializeWithHashstamp: MDHashstamp new 
		parents: anArray
		properties: properties! !

!MDMemo class methodsFor: 'instance creation' stamp: 'cwp 1/19/2007 22:26'!
snapshot: aSnapshot slice: aSlice parents: aSet properties: aPropertyDictionary
	^ (self parents: aSet properties: aPropertyDictionary)
		setSnapshot: aSnapshot slice: aSlice;
		yourself! !

!MDMemo methodsFor: 'comparing' stamp: 'cwp 12/31/2007 14:55'!
<= aMemo
	^ self hashstamp <= aMemo hashstamp! !

!MDMemo methodsFor: 'accessing' stamp: 'cwp 4/1/2008 23:35'!
description
	^ String streamContents: 
		[:stream |
		self printPropertiesOn: stream.
		stream cr.
		properties comment ifNotNilDo: [:c | stream nextPutAll: c]]! !

!MDMemo methodsFor: 'repository' stamp: 'cwp 11/28/2008 21:26'!
getSnapshotFrom: aRepository
	^ aRepository get: reference! !

!MDMemo methodsFor: 'initialize-release' stamp: 'cwp 1/19/2010 20:24'!
initializeWithHashstamp: aHashstamp parents: anArray properties: propdict
	self initializeWithHashstamp: aHashstamp.
	parents := anArray.
	properties := propdict.
! !

!MDMemo methodsFor: 'testing' stamp: 'cwp 1/19/2007 20:49'!
isMemo
	^ true! !

!MDMemo methodsFor: 'testing' stamp: 'cwp 1/19/2007 22:42'!
matchesSlice: aSlice
	^ sliceId = aSlice id! !

!MDMemo methodsFor: 'printing' stamp: 'cwp 12/28/2007 23:38'!
name
	
	^ String streamContents:
		[:stream | 
		self 
			printWithSliceName: properties sliceName 
			on: stream]! !

!MDMemo methodsFor: 'printing' stamp: 'cwp 12/28/2007 23:38'!
nameForSlice: aSlice
	
	^ String streamContents:
		[:stream | 
		self printWithSliceName: aSlice name on: stream]! !

!MDMemo methodsFor: 'accessing' stamp: 'cwp 1/15/2007 22:17'!
parents
	^ parents! !

!MDMemo methodsFor: 'printing' stamp: 'cwp 4/1/2008 23:37'!
printPropertiesOn: aStream
	
	| print dict |
	print := [:key :value |
			aStream 
				nextPutAll: key asString;
				nextPut: $:;
				space;
				print: value;
				cr].

	print value: #timestamp value: self timestamp.
	dict := properties copy
		removeKey: #initials ifAbsent: [];
		removeKey: #ordinal ifAbsent: [];
		removeKey: #comment ifAbsent: [];
		removeKey: #sliceName ifAbsent: [];
		yourself.
	dict keys asSortedArray do: [:key | print value: key value: (dict at: key)]! !

!MDMemo methodsFor: 'printing' stamp: 'cwp 5/22/2008 00:10'!
printWithSliceName: aString on: aStream
	| segment |
	aStream nextPutAll: aString.
	(segment := properties initials) ifNotNil: 
		[aStream position > 0 ifTrue: [aStream nextPut: $-].
		aStream nextPutAll: segment].
	(segment := properties ordinal) ifNotNil: 
		[aStream position > 0 ifTrue: [aStream nextPut: $.].
		aStream print: segment]! !

!MDMemo methodsFor: 'accessing' stamp: 'cwp 1/15/2007 22:17'!
properties
	^ properties! !

!MDMemo methodsFor: 'accessing' stamp: 'cwp 1/15/2007 22:16'!
reference
	^ reference! !

!MDMemo methodsFor: 'initialize-release' stamp: 'cwp 5/22/2008 00:10'!
setSnapshot: aSnapshot slice: aSlice
	reference := aSnapshot hashstamp.
	sliceId := aSlice id.
	properties sliceName: aSlice name.
	self initHashstamp! !

!MDMemo methodsFor: 'accessing' stamp: 'cwp 1/19/2007 22:24'!
sliceId
	^ sliceId! !

!MDMemo methodsFor: 'accessing' stamp: 'cwp 1/19/2007 23:03'!
sliceName
	^ properties sliceName! !

MDHashedObject subclass: #MDSnapshot
	instanceVariableNames: 'contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Versions'!

!MDSnapshot commentStamp: 'dc 6/14/2007 08:13' prior: 0!
This is a set of Versions which "go together." A snapshot is equivalent to an MCVersion in MC1. It's the unit at which code is moved between images.!

!MDSnapshot class methodsFor: 'instance creation' stamp: 'cwp 1/19/2010 20:30'!
withVersions: versions
	^ self basicNew
		initializeWithHashstamp: MDHashstamp new
		versions: versions! !

!MDSnapshot methodsFor: 'accessing' stamp: 'cwp 3/27/2005 22:39'!
contents
	^ contents! !

!MDSnapshot methodsFor: 'repository' stamp: 'cwp 1/19/2007 23:27'!
getVersionsFrom: aRepository
	^ contents collect: [:ea | aRepository get: ea]! !

!MDSnapshot methodsFor: 'repository' stamp: 'jf 9/8/2009 16:28'!
getVersionsFrom: aRepository for: aWorkspace
	| versions missing |
	versions := Set new.
	missing := Set new.
	contents do:
		[:hs |
		aWorkspace 
			versionForHashstamp: hs
			ifPresent: [:v | versions add: v]
			ifAbsent: [missing add: hs]].
	versions addAll: (aRepository getAll: missing).
	^ versions
! !

!MDSnapshot methodsFor: 'initialize-release' stamp: 'cwp 1/19/2010 20:29'!
initializeWithHashstamp: aHashstamp versions: aSet
	self initializeWithHashstamp: aHashstamp.
	contents := (aSet collect: [:ea | ea hashstamp]) asSet.
	! !

!MDSnapshot methodsFor: 'testing' stamp: 'cwp 1/1/2007 09:34'!
isSnapshot
	^ true! !

MDHashedObject subclass: #MDVersion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Versions'!

!MDVersion commentStamp: 'dc 6/14/2007 07:54' prior: 0!
This is the central class of MC2. It represents the state of an element at a particular point in the evolution of the system. It combines a variant with list of versions that have come before it. Each version has what we call a Hashstamp - combination of SHA1 hash and timestamp which uniquely identifies the version. A version's ancestry is a set of hashstamps specifying which versions are part of this version's history.!

MDVersion subclass: #MDElementVersion
	instanceVariableNames: 'variant ancestry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Versions'!

!MDElementVersion class methodsFor: 'instance creation' stamp: 'cwp 10/16/2005 14:19'!
variant: aVariant 
	^self variant: aVariant ancestry: Set new! !

!MDElementVersion class methodsFor: 'instance creation' stamp: 'cwp 1/19/2010 20:44'!
variant: aVariant ancestry: aSet 
	^ self basicNew
		initializeWithVariant: aVariant ancestry: aSet! !

!MDElementVersion methodsFor: 'accessing' stamp: 'avi 11/29/2004 13:53'!
ancestry
	^ ancestry! !

!MDElementVersion methodsFor: 'accessing' stamp: 'cwp 10/16/2005 13:50'!
element
	^variant element! !

!MDElementVersion methodsFor: 'accessing' stamp: 'cwp 3/23/2005 23:15'!
fullAncestry
	^ancestry copyWith: self hashstamp! !

!MDElementVersion methodsFor: 'initialize-release' stamp: 'cwp 1/19/2010 20:44'!
initializeWithVariant: aVariant ancestry: aCollection 
	self initializeWithHashstamp: MDHashstamp new.
	variant := aVariant.
	ancestry := aCollection.
	! !

!MDElementVersion methodsFor: 'comparing' stamp: 'cwp 3/23/2005 23:15'!
precedes: aVersion 
	^aVersion ancestry includes: self hashstamp! !

!MDElementVersion methodsFor: 'conflicts' stamp: 'jf 10/4/2009 20:21'!
resolveConflictWith: aVersion in: aDomain using: twoArgBlock 
	(self variant autoMergeWith: aVersion variant in: aDomain) 
		ifNotNilDo: [:snap | ^snap].
	^twoArgBlock value: self value: aVersion! !

!MDElementVersion methodsFor: 'initialize-release' stamp: 'cwp 8/9/2009 13:57'!
setVariant: aVariant ancestry: aCollection timestamp: aTimestamp 
	variant := aVariant.
	ancestry := aCollection.
	hashstamp := aTimestamp.
	self initHashstamp! !

!MDElementVersion methodsFor: 'accessing' stamp: 'cwp 10/16/2005 13:50'!
variant
	^variant! !

MDVersion subclass: #MDNullVersion
	instanceVariableNames: 'element'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Versions'!

!MDNullVersion class methodsFor: 'instance creation' stamp: 'cwp 1/19/2010 20:46'!
forElement: anElement
	^ self basicNew initializeWithElement: anElement! !

!MDNullVersion methodsFor: 'accessing' stamp: 'cwp 2/27/2005 22:24'!
ancestry
	^ Set new! !

!MDNullVersion methodsFor: 'accessing' stamp: 'cwp 2/27/2005 21:36'!
element
	^ element! !

!MDNullVersion methodsFor: 'accessing' stamp: 'cwp 2/27/2005 22:24'!
fullAncestry
	^ Set new! !

!MDNullVersion methodsFor: 'initialize-release' stamp: 'cwp 1/19/2010 20:45'!
initializeWithElement: anElement
	self initializeWithHashstamp: MDHashstamp new.
	element := anElement.
	! !

!MDNullVersion methodsFor: 'comparing' stamp: 'cwp 2/28/2005 21:47'!
precedes: anElementVersion 
	^true! !

!MDNullVersion methodsFor: 'initialize-release' stamp: 'cwp 1/19/2010 20:45'!
setElement: anElement
	self initializeWithHashstamp: MDHashstamp new.
	element := anElement.
	! !

!MDNullVersion methodsFor: 'accessing' stamp: 'cwp 10/16/2005 14:17'!
variant
	^ MDRemovalVariant forElement: element! !

!MDVersion methodsFor: 'comparing' stamp: 'dc 6/14/2007 07:55'!
conflictsWith: other
	^ ((self precedes: other)
			or: [self succeeds: other]) not! !

!MDVersion methodsFor: 'testing' stamp: 'cwp 11/28/2008 21:48'!
isVersion
	^ true! !

!MDVersion methodsFor: 'comparing' stamp: 'cwp 2/28/2005 21:47'!
succeeds: anElementVersion 
	^anElementVersion precedes: self! !

!MDVersion methodsFor: 'comparing' stamp: 'avi 3/21/2006 00:13'!
successor: other 
	(self = other) ifTrue: [^ self].
	(self succeeds: other) ifTrue: [^ self].
	(other succeeds: self) ifTrue: [^ other].
	^ nil! !

!MDVersion methodsFor: 'comparing' stamp: 'dc 6/14/2007 08:01'!
successor: other onConflict: aBlock 
	^ (self successor: other)
		ifNil: [MDElementVersion
					variant: aBlock value
					ancestry: self fullAncestry , other fullAncestry]! !

MDObject subclass: #MDHistorian
	instanceVariableNames: 'slice properties parents ordinal isDirty announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Environment'!

!MDHistorian class methodsFor: 'instance creation' stamp: 'jf 11/8/2009 16:59'!
forSlice: aSlice
	^ self basicNew
		initializeWithSlice: aSlice;
		yourself! !

!MDHistorian class methodsFor: 'instance creation' stamp: 'jf 11/8/2009 17:00'!
new
	self shouldNotImplement! !

!MDHistorian methodsFor: 'announcing' stamp: 'jf 11/19/2009 16:15'!
announce: anObject
	self announcer announce: anObject! !

!MDHistorian methodsFor: 'announcing' stamp: 'cwp 11/25/2009 15:06'!
announcer
	^ announcer! !

!MDHistorian methodsFor: 'accessing' stamp: 'cwp 5/22/2008 00:10'!
basicMemo
	| memo |
	memo := MDMemo parents: self parents.
	self update: memo properties.
	MDPlatform current updateMemoProperties: memo properties.
	memo properties ordinal: (self ordinal).
	^ memo! !

!MDHistorian methodsFor: 'accessing' stamp: 'cwp 6/1/2008 20:30'!
clearParents
	parents := OrderedCollection new! !

!MDHistorian methodsFor: 'accessing' stamp: 'cwp 8/14/2009 18:19'!
id
	^ slice id! !

!MDHistorian methodsFor: 'ordinals' stamp: 'cwp 5/22/2008 00:10'!
incrementOrdinal
	ordinal := ordinal + 1! !

!MDHistorian methodsFor: 'initialize-release' stamp: 'cwp 11/25/2009 15:06'!
initializeWithSlice: aSlice
	self initialize.
	announcer := MDAnnouncer new.
	slice := aSlice.
	properties := MDPropertyDictionary new.
	parents := OrderedCollection new.
	ordinal := 1.
	isDirty := false
	! !

!MDHistorian methodsFor: 'accessing' stamp: 'cwp 3/8/2008 21:27'!
isDirty
	^ isDirty! !

!MDHistorian methodsFor: 'accessing' stamp: 'jf 11/25/2009 15:41'!
markClean
	isDirty ifTrue: 
		[isDirty := false.
		self announce: (MDSliceClean slice: slice)]! !

!MDHistorian methodsFor: 'accessing' stamp: 'jf 11/25/2009 15:41'!
markDirty
	isDirty ifFalse: 
		[isDirty := true.
		self announce: (MDSliceDirty slice: slice)]! !

!MDHistorian methodsFor: 'accessing' stamp: 'cwp 5/22/2008 00:10'!
memo
	| memo name |
	memo := self basicMemo.
	name := memo nameForSlice: slice.
	^ (MDCommentRequest signal: 'Comment for ', name) ifNotNilDo:
		[:comment | 
		comment isEmpty ifFalse: [memo properties comment: comment].
		self incrementOrdinal.
		memo].
	! !

!MDHistorian methodsFor: 'notification' stamp: 'cwp 7/26/2008 17:49'!
noteElementChanged: anElement 
	(slice includes: anElement) ifTrue: [ self markDirty ]! !

!MDHistorian methodsFor: 'notification' stamp: 'cwp 3/8/2008 12:45'!
noteInclude: aMemo
	parents add: aMemo hashstamp.
	self noteOrdinal: aMemo properties ordinal ! !

!MDHistorian methodsFor: 'notification' stamp: 'cwp 8/3/2008 21:47'!
noteLoad: aMemo
	parents := OrderedCollection with: aMemo hashstamp.
	self noteOrdinal: aMemo properties ordinal.
	self markClean! !

!MDHistorian methodsFor: 'ordinals' stamp: 'cwp 5/22/2008 00:10'!
noteOrdinal: anInteger 
	
	anInteger ifNotNil: [ordinal := ordinal max: anInteger + 1]! !

!MDHistorian methodsFor: 'notification' stamp: 'cwp 8/3/2008 21:47'!
noteSave: aMemo
	parents := OrderedCollection with: aMemo hashstamp.
	self markClean! !

!MDHistorian methodsFor: 'ordinals' stamp: 'cwp 3/8/2008 12:35'!
ordinal
	^ ordinal! !

!MDHistorian methodsFor: 'accessing' stamp: 'cwp 3/8/2008 12:36'!
parents
	^ parents asArray! !

!MDHistorian methodsFor: 'accessing' stamp: 'cwp 12/27/2007 21:47'!
properties
	^ properties! !

!MDHistorian methodsFor: 'accessing' stamp: 'cwp 8/14/2009 08:46'!
slice
	^ slice! !

!MDHistorian methodsFor: 'updating' stamp: 'cwp 12/27/2007 21:27'!
update: props
	properties keysAndValuesDo: [:k :v | props at: k put: v]! !

MDObject subclass: #MDMaterializer
	instanceVariableNames: 'decoder'
	classVariableNames: 'Types'
	poolDictionaries: ''
	category: 'MC2-Core-Serialization'!

!MDMaterializer class methodsFor: 'initialization' stamp: 'cwp 9/1/2008 19:39'!
initialize
	self initializeTypes! !

!MDMaterializer class methodsFor: 'initialization' stamp: 'cwp 11/15/2008 12:29'!
initializeTypes
	Types := #(
		materializeObject
		materializeClass
		materializeClass
		materializeClass
		materializeKnownClass
		materializeNil
		materializeTrue
		materializeFalse
		materializeByte		
		materializeSmallPositiveInteger
		materializeSmallNegativeInteger
		materializeLargePositiveInteger
		materializeLargeNegativeInteger
		materializeSymbol
		materializeUtf8String
		materializeUtf16String
		materializeArray
		materializeSet
		materializeDictionary
		materializeProperties
		materializeTimestamp
		materializeHashstamp
		materializeHashedObject
	)! !

!MDMaterializer class methodsFor: 'testing' stamp: 'cwp 11/15/2008 12:57'!
isMemo: aByteArray
	"Evil hack to check whether a serialized object is an instance
	MDMemo, without actually materializing it."

	^ aByteArray beginsWith: #(23 5 9 7)! !

!MDMaterializer class methodsFor: 'materializing' stamp: 'cwp 8/31/2008 15:57'!
materialize: aByteArray
	^ self materializeFrom: aByteArray readStream! !

!MDMaterializer class methodsFor: 'materializing' stamp: 'cwp 8/31/2008 15:59'!
materializeFrom: aReadStream
	| instance |
	instance := self on: aReadStream.
	^ instance materialize! !

!MDMaterializer class methodsFor: 'instance creation' stamp: 'jf 11/8/2009 18:58'!
new
	self shouldNotImplement! !

!MDMaterializer class methodsFor: 'instance creation' stamp: 'jf 11/8/2009 18:47'!
on: aReadStream
	^ self basicNew
		initializeWithStream: aReadStream;
		yourself! !

!MDMaterializer methodsFor: 'initialize-release' stamp: 'jf 11/8/2009 18:46'!
initializeWithStream: aStream
	self initialize.
	decoder := MDObjectDecoder on: aStream.
	! !

!MDMaterializer methodsFor: 'private' stamp: 'cwp 11/15/2008 12:31'!
knownClasses
	^ { 
		MDSliceElement.
		MDDefinitionVariant.
		MDRemovalVariant.
		MDNullVersion.
		MDElementVersion.
		MDSnapshot.
		MDMemo.
		MDFakeElement.
		MDClassElement.
		MDClassCommentElement.
		MDInstVarElement.
		MDClassVarElement.
		MDClassInstVarElement.
		MDPoolImportElement.
		MDMethodElement
	 }! !

!MDMaterializer methodsFor: 'public' stamp: 'cwp 9/1/2008 20:02'!
materialize
	| type selector |
	type := decoder getType.
	selector := Types 
		at: type
		ifAbsent: [ self error: 'unrecognized type' ].
	^ self perform: selector! !

!MDMaterializer methodsFor: 'types' stamp: 'cwp 11/15/2008 12:49'!
materializeArray
	| size array |
	size := self materialize.
	array := Array new: size.
	1 	to: size
		do:	[:i | array at: i put: self materialize ].
	^ array! !

!MDMaterializer methodsFor: 'types' stamp: 'cwp 11/15/2008 12:49'!
materializeBlockContext
	| method sender pc numArgs startpc home context |
	context := Object new.
	method := self materialize.
	sender := self materialize.
	pc := self materialize.
	numArgs := self materialize.
	startpc := self materialize.
	home := self materialize.
	context become: (BlockContext newForMethod: method).
	context
		home: home startpc: startpc nargs: numArgs ;
		swapSender: sender ;
		pc: pc.
	^ context! !

!MDMaterializer methodsFor: 'types' stamp: 'cwp 9/1/2008 19:54'!
materializeByte
	^ decoder getByte! !

!MDMaterializer methodsFor: 'types' stamp: 'cwp 11/15/2008 12:49'!
materializeClass
	| name class |
	name := self materialize.
	class := Smalltalk at: name.

	"consume the inst var names"
	self materialize timesRepeat: [ self materialize ].
	^ class! !

!MDMaterializer methodsFor: 'types' stamp: 'cwp 11/15/2008 12:49'!
materializeDictionary
	| size dictionary |
	size := self materialize.
	dictionary := Dictionary new: size.
	size timesRepeat: 
		[ dictionary 
			at: self materialize
			put: self materialize ].
	^ dictionary! !

!MDMaterializer methodsFor: 'types' stamp: 'cwp 11/15/2008 12:30'!
materializeFalse
	^ false! !

!MDMaterializer methodsFor: 'types' stamp: 'cwp 9/1/2008 19:59'!
materializeFloat
	^ decoder getFloat! !

!MDMaterializer methodsFor: 'types' stamp: 'cwp 8/9/2009 00:53'!
materializeHashedObject
	| object |
	object := self materialize basicNew.
	1
		to: object class instSize 
		do: [:i | object instVarAt: i put: (self materialize)].
	^ object! !

!MDMaterializer methodsFor: 'types' stamp: 'cwp 11/15/2008 12:45'!
materializeHashstamp
	| ts |
	ts := MDHashstamp new.
	decoder getBytesInto: ts.
	^ ts! !

!MDMaterializer methodsFor: 'types' stamp: 'cwp 11/15/2008 12:32'!
materializeKnownClass
	| index |
	index := self materialize.
	^ self knownClasses at: index! !

!MDMaterializer methodsFor: 'types' stamp: 'cwp 9/2/2008 07:31'!
materializeLargeNegativeInteger
	| size |
	size := self materialize.
	^ (decoder getIntegerOfSize: size) negated! !

!MDMaterializer methodsFor: 'types' stamp: 'cwp 9/2/2008 07:31'!
materializeLargePositiveInteger
	| size |
	size := self materialize.
	^ decoder getIntegerOfSize: size! !

!MDMaterializer methodsFor: 'types' stamp: 'cwp 11/15/2008 12:49'!
materializeMethodContext
	| method sender pc stackp env receiver context |
	context := Object new.
	method := self materialize.
	sender := self materialize.
	pc := self materialize.
	stackp := self materialize.
	env := self materialize.
	receiver := self materialize.
	context become: (MethodContext newForMethod: method).
	context
		setSender: sender
			receiver: receiver
			method: method
			arguments: #() ;
		pc: pc ;
		stackp: stackp ;
		myEnv: env.
	self readPointersInto: context.
	^ context! !

!MDMaterializer methodsFor: 'types' stamp: 'cwp 11/15/2008 12:30'!
materializeNil
	^ nil! !

!MDMaterializer methodsFor: 'types' stamp: 'cwp 11/15/2008 12:49'!
materializeObject
	| theClass object tmp |
	object := Object new.
	theClass := self materialize.
	tmp := theClass isVariable 
		ifTrue: [ theClass new: self materialize ]
		ifFalse: [ theClass basicNew ].
	object become: tmp.
	1 
		to: object class instSize
		do: 
			[ : i | 
			object 
				instVarAt: i
				put: self materialize ].
	object class isVariable ifTrue: 
		[ object class isPointers 
			ifTrue: [ self readPointersInto: object ]
			ifFalse: [ decoder getBytesInto: object ] ].
	^ object! !

!MDMaterializer methodsFor: 'types' stamp: 'cwp 11/15/2008 12:35'!
materializeProperties
	| size dictionary |
	size := self materialize.
	dictionary := MDPropertyDictionary new: size.
	size timesRepeat: 
		[ dictionary 
			at: self materialize
			put: self materialize ].
	^ dictionary! !

!MDMaterializer methodsFor: 'types' stamp: 'cwp 11/15/2008 12:49'!
materializeSet
	| size set |
	size := self materialize.
	set := Set new: size.
	size timesRepeat: [ set add: self materialize ].
	^ set! !

!MDMaterializer methodsFor: 'types' stamp: 'cwp 9/1/2008 19:55'!
materializeSingleton
	^ decoder getSingleton! !

!MDMaterializer methodsFor: 'types' stamp: 'cwp 9/1/2008 19:57'!
materializeSmallNegativeInteger
	^ decoder getSmallInteger negated! !

!MDMaterializer methodsFor: 'types' stamp: 'cwp 9/1/2008 19:58'!
materializeSmallPositiveInteger
	^ decoder getSmallInteger! !

!MDMaterializer methodsFor: 'types' stamp: 'cwp 9/2/2008 07:35'!
materializeSymbol
	^ self materializeUtf8String asSymbol! !

!MDMaterializer methodsFor: 'types' stamp: 'cwp 11/15/2008 12:45'!
materializeTimestamp
	| ts |
	ts := MDTimestamp new.
	decoder getBytesInto: ts.
	^ ts! !

!MDMaterializer methodsFor: 'types' stamp: 'cwp 11/15/2008 12:30'!
materializeTrue
	^ true! !

!MDMaterializer methodsFor: 'types' stamp: 'cwp 9/2/2008 07:42'!
materializeUtf16String
	| size |
	size := self materialize.
	^ decoder getUtf16StringOfSize: size.
	! !

!MDMaterializer methodsFor: 'types' stamp: 'cwp 9/2/2008 07:41'!
materializeUtf8String
	| size |
	size := self materialize.
	^ decoder getUtf8StringOfSize: size.
	! !

!MDMaterializer methodsFor: 'private' stamp: 'cwp 9/3/2008 19:43'!
readPointersInto: anObject 

	1	to: anObject size
		do:	[ :i | anObject at: i put: self materialize ]! !

MDObject subclass: #MDMerge
	instanceVariableNames: 'local remote resolution'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Utilities'!

!MDMerge class methodsFor: 'instance creation' stamp: 'jf 11/8/2009 18:32'!
local: localVersion remote: remoteVersion
	^ self basicNew
		initializeWithLocal: localVersion remote: remoteVersion;
		yourself! !

!MDMerge class methodsFor: 'instance creation' stamp: 'jf 11/8/2009 18:58'!
new
	self shouldNotImplement! !

!MDMerge class methodsFor: 'instance creation' stamp: 'jf 11/8/2009 18:32'!
toInclude: aVersion in: aWorkspace 
	| local |
	local := aWorkspace versionForElement: aVersion element.
	^ self local: local remote: aVersion
! !

!MDMerge methodsFor: 'operations' stamp: 'jf 9/8/2009 16:33'!
applyTo: aWorkspace
	aWorkspace includeVersion: resolution onConflict: [:l :r | r variant]! !

!MDMerge methodsFor: 'operations' stamp: 'cwp 5/22/2008 00:10'!
chooseLocal
	resolution := local! !

!MDMerge methodsFor: 'operations' stamp: 'cwp 5/22/2008 00:10'!
chooseRemote
	resolution := remote! !

!MDMerge methodsFor: 'printing' stamp: 'cwp 10/25/2008 14:39'!
displayOn: aStream
	self remote element printOn: aStream! !

!MDMerge methodsFor: 'initialize-release' stamp: 'jf 11/8/2009 18:30'!
initializeWithLocal: localVersion remote: remoteVersion
	self initialize.
	local := localVersion.
	remote := remoteVersion.
	resolution := local successor: remote! !

!MDMerge methodsFor: 'testing' stamp: 'cwp 3/17/2005 23:21'!
isConflict
	^ remote conflictsWith: local! !

!MDMerge methodsFor: 'testing' stamp: 'cwp 3/17/2005 23:16'!
isLocal
	^ resolution == local! !

!MDMerge methodsFor: 'testing' stamp: 'avi 3/21/2006 00:14'!
isNoOp
	^ local = remote! !

!MDMerge methodsFor: 'testing' stamp: 'cwp 3/17/2005 23:19'!
isRemote
	^ resolution == remote! !

!MDMerge methodsFor: 'testing' stamp: 'cwp 6/9/2005 09:01'!
isResolved
	^ resolution notNil! !

!MDMerge methodsFor: 'accessing' stamp: 'cwp 3/17/2005 23:28'!
local
	^ local! !

!MDMerge methodsFor: 'accessing' stamp: 'cwp 3/17/2005 23:28'!
remote
	^ remote! !

!MDMerge methodsFor: 'accessing' stamp: 'cwp 3/17/2005 23:28'!
resolution
	^ resolution! !

!MDObject class methodsFor: 'defaults' stamp: 'jf 11/8/2009 16:22'!
defaultErrorClass
	^ MDError! !

MDObject subclass: #MDObjectDecoder
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Serialization'!

!MDObjectDecoder class methodsFor: 'instance creation' stamp: 'jf 11/8/2009 18:58'!
new
	self shouldNotImplement! !

!MDObjectDecoder class methodsFor: 'instance creation' stamp: 'jf 11/8/2009 18:49'!
on: aReadStream
	^ self basicNew
		initializeWithStream: aReadStream;
		yourself! !

!MDObjectDecoder methodsFor: 'public' stamp: 'cwp 8/31/2008 19:30'!
getByte
	^ stream next! !

!MDObjectDecoder methodsFor: 'public' stamp: 'cwp 9/2/2008 00:50'!
getBytesInto: anObject 
	1 
		to: anObject byteSize
		do: 
			[ : index | 
			anObject 
				byteAt: index
				put: stream next ]! !

!MDObjectDecoder methodsFor: 'public' stamp: 'cwp 9/2/2008 07:32'!
getFloat
	| hi lo |
	hi := self getIntegerOfSize: 4.
	lo := self getIntegerOfSize: 4.
	^ (Float basicNew: 2)
		at: 1 put: hi;
		at: 2 put: lo;
		yourself! !

!MDObjectDecoder methodsFor: 'public' stamp: 'cwp 9/2/2008 07:32'!
getIntegerOfSize: size 
	| value |
	value := 0.
	size timesRepeat: [value := (value bitShift: 8) bitOr: stream next].
	^ value! !

!MDObjectDecoder methodsFor: 'public' stamp: 'cwp 9/1/2008 19:34'!
getSingleton
	| index |
	index := stream next.
	^ #(nil true false) at: index! !

!MDObjectDecoder methodsFor: 'public' stamp: 'cwp 8/31/2008 16:46'!
getSmallInteger
	| hi lo |
	hi := stream next.
	lo := stream next.
	^ (hi bitShift: 8) + lo! !

!MDObjectDecoder methodsFor: 'public' stamp: 'cwp 8/31/2008 16:45'!
getType
	^ stream next! !

!MDObjectDecoder methodsFor: 'public' stamp: 'cwp 9/2/2008 07:44'!
getUtf16StringOfSize: size 
	| string |
	string := WideString new: size.
	1 to: size do: 
		[ :index | 
		string at: index put: self readUtf16Character ].
	^ string! !

!MDObjectDecoder methodsFor: 'public' stamp: 'cwp 9/2/2008 07:43'!
getUtf8StringOfSize: size
	| string |
	string := ByteString new: size.
	1 to: size do: [:index | string at: index put: self readUtf8Character].
	^ string! !

!MDObjectDecoder methodsFor: 'initialize-release' stamp: 'jf 11/8/2009 18:49'!
initializeWithStream: aReadStream
	self initialize.
	stream := aReadStream.
! !

!MDObjectDecoder methodsFor: 'private' stamp: 'cwp 8/31/2008 22:39'!
readTwoBytes
	| hi lo |
	hi := stream next.
	lo := stream next.
	^ (hi bitShift: 8) bitOr: lo! !

!MDObjectDecoder methodsFor: 'private' stamp: 'cwp 8/31/2008 22:37'!
readUtf16Character
	| value |
	value := self readTwoBytes.
	^ (value < 56320 or: [ value > 57343 ]) 
		ifTrue: [ Unicode value: value ]
		ifFalse: [ self readUtf16CharacterGiven: value ]! !

!MDObjectDecoder methodsFor: 'private' stamp: 'cwp 8/31/2008 22:44'!
readUtf16CharacterGiven: first
	| second |
	second := self readTwoBytes.
	^ Unicode value: ((first bitShift: 10) bitOr: second) + 16r10000! !

!MDObjectDecoder methodsFor: 'private' stamp: 'cwp 9/9/2008 08:00'!
readUtf8Character
	| value |
	value := stream next.
	value <= 127 
		ifTrue: [ ^ Unicode value: value ]
		ifFalse: 
			[value <= 223 
				ifTrue: 
					[ value := (value bitAnd: 31) bitShift: 6.
					value := value bitOr: (stream next bitAnd: 63)]
				ifFalse: 
					[ value := (value bitAnd: 15) bitShift: 12.
					value := value bitOr: ((stream next bitAnd: 63) bitShift: 6).
					value := value bitOr: (stream next bitAnd: 63)].
			^ Unicode value: value ]! !

MDObject subclass: #MDObjectEncoder
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Serialization'!

MDObjectEncoder class
	instanceVariableNames: 'stream'!

MDObjectEncoder class
	instanceVariableNames: 'stream'!

!MDObjectEncoder class methodsFor: 'instance creation' stamp: 'jf 11/8/2009 18:57'!
new
	self shouldNotImplement! !

!MDObjectEncoder class methodsFor: 'instance creation' stamp: 'jf 11/8/2009 18:50'!
on: aWriteStream
	^ self basicNew
		initializeWithStream: aWriteStream;
		yourself! !

!MDObjectEncoder methodsFor: 'initialize-release' stamp: 'jf 11/8/2009 18:50'!
initializeWithStream: aWriteStream
	self initialize.
	stream := aWriteStream! !

!MDObjectEncoder methodsFor: 'public' stamp: 'cwp 8/31/2008 19:24'!
putByte: anInteger
	stream nextPut: anInteger! !

!MDObjectEncoder methodsFor: 'public' stamp: 'cwp 9/2/2008 00:44'!
putBytesFrom: anObject
	1 
		to: anObject byteSize 
		do: [:index | stream nextPut: (anObject byteAt: index)]! !

!MDObjectEncoder methodsFor: 'public' stamp: 'cwp 8/31/2008 20:19'!
putFloat: aFloat
	self write32BitInteger: (aFloat at: 1).
	self write32BitInteger: (aFloat at: 2).! !

!MDObjectEncoder methodsFor: 'public' stamp: 'cwp 9/2/2008 07:24'!
putLargeInteger: anInteger size: size
	| byte |
	(size - 1 to: 0 by: -1) do:
		[:index |
		byte := (anInteger bitShift: index * -8) bitAnd: 255.
		stream nextPut: byte]! !

!MDObjectEncoder methodsFor: 'public' stamp: 'cwp 11/12/2008 20:39'!
putSingleton: anObject
	| index |
	index := #(nil true false) indexOf: anObject.
	stream nextPut: index + 5! !

!MDObjectEncoder methodsFor: 'public' stamp: 'cwp 8/31/2008 16:38'!
putSmallInteger: anInteger
	stream nextPut: (anInteger bitShift: -8).
	stream nextPut: (anInteger bitAnd: 255). 3! !

!MDObjectEncoder methodsFor: 'public' stamp: 'cwp 8/31/2008 16:28'!
putType: aByte
	stream nextPut: aByte! !

!MDObjectEncoder methodsFor: 'public' stamp: 'cwp 9/2/2008 07:25'!
putUtf16String: aString
	| value |
	aString do:
		[:char |
		value := char asUnicode.
		value < 16r10000 
			ifTrue: [self writeTwoByteCode: value]
			ifFalse: [self writeFourByteCode: value]]! !

!MDObjectEncoder methodsFor: 'public' stamp: 'cwp 9/2/2008 07:25'!
putUtf8String: aString
	
	aString do: [ :char | self writeUtf8Code: char asUnicode ]! !

!MDObjectEncoder methodsFor: 'private' stamp: 'cwp 8/31/2008 20:18'!
write32BitInteger: anInteger
	stream		
		nextPut: (anInteger bitShift: -24);
		nextPut: ((anInteger bitShift: -16) bitAnd: 255);
		nextPut: ((anInteger bitShift: -8) bitAnd: 255);
		nextPut: (anInteger bitAnd: 255)! !

!MDObjectEncoder methodsFor: 'private' stamp: 'cwp 8/31/2008 22:28'!
writeFourByteCode: anInteger
	| value |
	value := 16r10000 - anInteger.
	stream nextPut: ((value bitShift: -18) bitOr: 16rD8).
	stream nextPut: ((value bitShift: -10) bitAnd: 16rFF).
	stream nextPut: ((value bitShift: -8) bitOr: 16rDC).
	stream nextPut: (value bitAnd: 16rFF).
	

! !

!MDObjectEncoder methodsFor: 'private' stamp: 'cwp 8/31/2008 22:27'!
writeTwoByteCode: value
	stream nextPut: (value bitShift: -8).
	stream nextPut: (value bitAnd: 16rFF).! !

!MDObjectEncoder methodsFor: 'private' stamp: 'cwp 8/31/2008 22:23'!
writeUtf8Code: value
	value <= 16r7F
		ifTrue: [stream nextPut: value]
		ifFalse:
			[value <= 16r7FF
				ifTrue: 
					[stream nextPut: ((value bitShift: -6) bitOr: 16rC0).
					stream nextPut: ((value bitAnd: 16r3F) bitOr: 16r80)]
				ifFalse:
					[value <= 16rFFFF
						ifTrue:
							[stream nextPut: ((value bitShift: -12) bitOr: 16rE0).
							stream nextPut: (((value bitShift: -6) bitAnd: 16r3F) bitOr: 16r80).
							stream nextPut: ((value bitAnd: 16r3F) bitOr: 16r80)]]]! !

MDObject subclass: #MDPearsonsHash
	instanceVariableNames: 'value'
	classVariableNames: 'Cipher'
	poolDictionaries: ''
	category: 'MC2-Core-Utilities'!

!MDPearsonsHash class methodsFor: 'as yet unclassified' stamp: 'cwp 8/3/2009 18:40'!
hashMessage: bytes
	^ self new 
		nextPutAll: bytes; 
		value! !

!MDPearsonsHash class methodsFor: 'as yet unclassified' stamp: 'cwp 8/3/2009 18:12'!
initialize
	Cipher := #(233 180 75 24 226 106 137 114 122 62 201 20 96 23 73 237 93 103 79 225 171 241 221 29 194 113 136 44 207 250 45 83 209 15 158 87 248 35 7 153 116 42 95 230 178 216 26 232 57 150 58 48 2 71 117 195 165 173 214 60 161 200 249 220 77 191 97 166 193 227 52 46 31 92 143 167 164 236 224 134 56 142 243 185 197 247 217 246 179 80 244 22 21 231 32 155 124 49 204 205 182 54 133 18 14 211 64 76 47 163 13 156 90 212 28 187 210 128 102 138 132 121 17 40 104 39 61 101 170 151 98 186 91 126 115 119 235 206 125 55 30 229 99 145 111 9 127 218 43 86 65 123 59 130 19 251 53 74 94 172 34 240 36 51 141 160 12 139 78 38 89 3 203 234 254 188 11 162 184 41 222 112 109 105 140 154 33 50 147 190 245 107 181 208 88 189 6 242 66 175 110 16 149 135 100 129 0 196 183 157 152 228 63 255 144 252 199 69 27 146 118 192 131 215 37 177 68 148 4 168 81 213 8 253 223 169 1 120 159 5 198 67 238 108 239 176 174 72 10 85 202 70 84 82 25 219) asByteArray! !

!MDPearsonsHash methodsFor: 'as yet unclassified' stamp: 'jf 11/8/2009 18:34'!
initialize
	super initialize.
	value := 0! !

!MDPearsonsHash methodsFor: 'as yet unclassified' stamp: 'cwp 8/3/2009 19:40'!
next: count putAll: aCollection startingAt: start
	start to: start + count -1 do:
		[:index | self nextPut: (aCollection byteAt: index)]! !

!MDPearsonsHash methodsFor: 'as yet unclassified' stamp: 'cwp 8/3/2009 18:36'!
nextPut: aByte
	value := Cipher at: (aByte bitXor: value) + 1! !

!MDPearsonsHash methodsFor: 'as yet unclassified' stamp: 'cwp 8/3/2009 18:39'!
nextPutAll: aCollection
	1 
		to: aCollection byteSize 
		do:
			[:i | self nextPut: (aCollection byteAt: i)]! !

!MDPearsonsHash methodsFor: 'as yet unclassified' stamp: 'cwp 8/3/2009 18:31'!
printOn: aStream
	self class printOn: aStream.
	aStream nextPut: $(.
	value printOn: aStream.
	aStream nextPut: $)! !

!MDPearsonsHash methodsFor: 'as yet unclassified' stamp: 'cwp 8/3/2009 18:01'!
value
	^ value! !

MDObject subclass: #MDRegistry
	instanceVariableNames: 'objects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Environment'!

!MDRegistry class methodsFor: 'as yet unclassified' stamp: 'cwp 11/20/2008 18:53'!
new
	^ self basicNew initialize! !

!MDRegistry methodsFor: 'as yet unclassified' stamp: 'cwp 11/9/2007 22:23'!
commit! !

!MDRegistry methodsFor: 'testing' stamp: 'cwp 11/9/2007 21:42'!
includesId: id
	^ objects includesKey: id! !

!MDRegistry methodsFor: 'initialization' stamp: 'jf 11/8/2009 17:08'!
initialize
	super initialize.
	objects := Dictionary new.
	! !

!MDRegistry methodsFor: 'accessing' stamp: 'cwp 6/14/2008 13:32'!
objectWithId: id
	^ objects at: id ifAbsent: [nil]! !

!MDRegistry methodsFor: 'accessing' stamp: 'cwp 8/14/2009 18:13'!
objectWithId: id ifAbsent: aBlock
	^ objects at: id ifAbsent: aBlock! !

!MDRegistry methodsFor: 'accessing' stamp: 'cwp 11/9/2007 22:00'!
objectWithId: id satisfies: aBlock
	^ aBlock value: (objects at: id ifAbsent: [^ false])! !

!MDRegistry methodsFor: 'accessing' stamp: 'cwp 11/9/2007 21:29'!
objects
	^ objects values! !

!MDRegistry methodsFor: 'adding' stamp: 'jf 9/26/2009 01:46'!
register: anObject
	^ objects at: anObject id put: anObject! !

!MDRegistry methodsFor: 'removing' stamp: 'cwp 11/19/2007 23:36'!
unregister: anObject
	^ self unregisterId: anObject id! !

!MDRegistry methodsFor: 'removing' stamp: 'jf 9/8/2009 23:36'!
unregister: anObject ifAbsent: absentBlock
	^ self unregisterId: anObject id ifAbsent: absentBlock! !

!MDRegistry methodsFor: 'removing' stamp: 'jf 9/8/2009 23:34'!
unregisterId: id
	^ self unregisterId: id ifAbsent: [nil]! !

!MDRegistry methodsFor: 'removing' stamp: 'jf 9/8/2009 23:34'!
unregisterId: id ifAbsent: absentBlock
	^ objects removeKey: id ifAbsent: absentBlock! !

MDObject subclass: #MDReplicator
	instanceVariableNames: 'source dest'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Utilities'!

!MDReplicator class methodsFor: 'instance creation' stamp: 'jf 11/8/2009 18:37'!
from: sourceRepository to: destRepository
	^ self basicNew
		initializeWithSource: sourceRepository destination: destRepository;
		yourself! !

!MDReplicator class methodsFor: 'instance creation' stamp: 'jf 11/8/2009 18:58'!
new
	self shouldNotImplement! !

!MDReplicator methodsFor: 'as yet unclassified' stamp: 'cwp 10/26/2008 20:46'!
copyAll
	source memos do: [:ea | self copyMemo: ea]! !

!MDReplicator methodsFor: 'as yet unclassified' stamp: 'cwp 10/26/2008 20:40'!
copyMemo: aMemo
	| objects snapshot |
	objects := Set new.
	objects add: aMemo.
	snapshot := source get: aMemo reference.
	objects add: snapshot.
	objects addAll: (snapshot getVersionsFrom: source).
	dest putAll: objects! !

!MDReplicator methodsFor: 'initialize-release' stamp: 'jf 11/8/2009 18:36'!
initializeWithSource: sourceRepository destination: destRepository
	self initialize.
	source := sourceRepository.
	dest := destRepository.! !

!MDReplicator methodsFor: 'as yet unclassified' stamp: 'cwp 10/26/2008 21:03'!
reject: aBlock
	source memos do:
		[:memo | 
		(aBlock value: memo) ifFalse: [self copyMemo: memo]]! !

!MDReplicator methodsFor: 'as yet unclassified' stamp: 'cwp 10/26/2008 20:59'!
select: aBlock
	source memos do:
		[:memo | 
		(aBlock value: memo) ifTrue: [self copyMemo: memo]]! !

MDObject subclass: #MDSerializer
	instanceVariableNames: 'encoder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Serialization'!

!MDSerializer class methodsFor: 'instance creation' stamp: 'jf 11/8/2009 18:57'!
new
	self shouldNotImplement! !

!MDSerializer class methodsFor: 'instance creation' stamp: 'jf 11/8/2009 18:56'!
on: aWriteStream
	^ self basicNew
		initializeWithStream: aWriteStream;
		yourself! !

!MDSerializer class methodsFor: 'serializing' stamp: 'cwp 11/11/2008 23:19'!
serialize: anObject
	| stream |
	stream := (ByteArray new: 100) writeStream.
	self serialize: anObject on: stream.
	^ stream contents! !

!MDSerializer class methodsFor: 'serializing' stamp: 'cwp 11/11/2008 23:19'!
serialize: anObject on: aStream
	(self on: aStream) serialize: anObject.
	! !

!MDSerializer methodsFor: 'private' stamp: 'cwp 9/4/2008 08:03'!
indexOf: anObject in: anIndex ifPresent: pBlock ifAbsent: aBlock
	| id |
	(anIndex includesKey: anObject)
		ifTrue: 
			[id := anIndex at: anObject.
			pBlock value: id]
		ifFalse:
			[id := anIndex size + 1.
			anIndex at: anObject put: id.
			aBlock value: id].
	
		! !

!MDSerializer methodsFor: 'initialize-release' stamp: 'jf 11/8/2009 18:56'!
initializeWithStream: aWriteStream
	self initialize.
	encoder := MDObjectEncoder on: aWriteStream.
	! !

!MDSerializer methodsFor: 'private' stamp: 'cwp 11/15/2008 11:54'!
knownClasses
	^ { 
		MDSliceElement.
		MDDefinitionVariant.
		MDRemovalVariant.
		MDNullVersion.
		MDElementVersion.
		MDSnapshot.
		MDMemo.
		MDFakeElement.
		MDClassElement.
		MDClassCommentElement.
		MDInstVarElement.
		MDClassVarElement.
		MDClassInstVarElement.
		MDPoolImportElement.
		MDMethodElement
	 }! !

!MDSerializer methodsFor: 'public' stamp: 'cwp 11/20/2008 19:18'!
serialize: anObject 
	anObject mdSerializeWith: self! !

!MDSerializer methodsFor: 'private' stamp: 'cwp 11/11/2008 23:05'!
serialize: anObject with: aBlock 
	aBlock value! !

!MDSerializer methodsFor: 'types' stamp: 'cwp 11/12/2008 20:24'!
serializeArray: anArray
	self serialize: anArray with:
		[encoder putType: 17.
		self serialize: anArray size.
		anArray do: [:ea | self serialize: ea]]! !

!MDSerializer methodsFor: 'types' stamp: 'cwp 9/23/2008 07:50'!
serializeBlockContext: aContext
	self serialize: aContext with:
		[encoder putType: 21.
		self serialize: aContext method.
		self serialize: aContext sender.
		self serialize: aContext pc.
		self serialize: aContext numArgs.
		self serialize: aContext startpc.
		self serialize: aContext home]! !

!MDSerializer methodsFor: 'types' stamp: 'cwp 11/12/2008 20:30'!
serializeByte: anInteger 
	encoder putType: 9.
	encoder putByte: anInteger.
	! !

!MDSerializer methodsFor: 'types' stamp: 'cwp 11/15/2008 11:54'!
serializeClass: aClass
	| index |
	index := self knownClasses indexOf: aClass.
	index = 0
		ifTrue: [self serializeFullClass: aClass]
		ifFalse:
			[encoder putType: 5.
			self serialize: index]! !

!MDSerializer methodsFor: 'types' stamp: 'cwp 11/12/2008 22:59'!
serializeDictionary: aDictionary

	encoder putType: 19.
	self serialize: aDictionary size.
	aDictionary keys asArray sort do:
		[:key |
		self serialize: key.
		self serialize: (aDictionary at: key)]! !

!MDSerializer methodsFor: 'types' stamp: 'cwp 8/31/2008 19:51'!
serializeFloat: aFloat
	encoder putType: 16.
	encoder putFloat: aFloat! !

!MDSerializer methodsFor: 'types' stamp: 'cwp 11/15/2008 11:51'!
serializeFullClass: aClass
	| type vars |
	
	type :=  aClass isVariable 
		ifFalse: [2]				"named inst vars only"
		ifTrue: 
			[aClass isPointers 
				ifTrue: [3]		"named + indexed object references"
				ifFalse: [4]].	"bytes or words"
		
	encoder putType: type.
	vars := aClass allInstVarNames.
	self serialize: aClass name.
	self serialize: vars size.
	vars do: [:ea | self serialize: ea]! !

!MDSerializer methodsFor: 'types' stamp: 'cwp 8/9/2009 00:56'!
serializeHashedObject: anObject
	encoder putType: 23.
	self serialize: anObject class.
	1
		to: anObject class instSize
		do: [:i | self serialize: (anObject instVarAt: i)]! !

!MDSerializer methodsFor: 'types' stamp: 'cwp 11/12/2008 22:17'!
serializeHashstamp: aHashstamp
	encoder putType: 22.
	encoder putBytesFrom: aHashstamp! !

!MDSerializer methodsFor: 'types' stamp: 'cwp 11/12/2008 21:54'!
serializeInteger: anInteger 
	anInteger < -65535 ifTrue: 
		[ ^ self 
			writeLargeInteger: anInteger negated
			type: 13 ].
	anInteger < 0 ifTrue: [ ^ self serializeSmallNegativeInteger: anInteger ].
	anInteger < 256 ifTrue: [ ^ self serializeByte: anInteger ].
	anInteger < 65535 ifTrue: [ ^ self serializeSmallPositiveInteger: anInteger ].
	self 
		writeLargeInteger: anInteger
		type: 12! !

!MDSerializer methodsFor: 'types' stamp: 'cwp 11/12/2008 22:02'!
serializeMethodContext: aContext 
	self 
		serialize: aContext
		with: 
			[ encoder putType: 22.
			self serialize: aContext method.
			self serialize: aContext sender.
			self serialize: aContext pc.
			self serialize: aContext stackPtr.
			self serialize: aContext myEnv.
			self serialize: aContext receiver.
			self writePointersFrom: aContext ]! !

!MDSerializer methodsFor: 'types' stamp: 'cwp 11/12/2008 22:03'!
serializeObject: anObject 
	encoder putType: 1.
	self serialize: anObject class.
	1	to: anObject class instSize
		do: [:i | self serialize: (anObject instVarAt: i)].
	anObject class isVariable ifTrue: 
		[self serialize: anObject size.
		anObject class isPointers 
			ifTrue: [self writePointersFrom: anObject]
			ifFalse: [encoder putBytesFrom: anObject]]! !

!MDSerializer methodsFor: 'types' stamp: 'cwp 11/12/2008 23:00'!
serializeProperties: aPropertyDictionary
	encoder putType: 20.
	self serialize: aPropertyDictionary size.
	aPropertyDictionary keys asArray sort do:
		[:key |
		self serialize: key.
		self serialize: (aPropertyDictionary at: key)]! !

!MDSerializer methodsFor: 'types' stamp: 'cwp 9/3/2008 19:15'!
serializeReference: anInteger
	encoder putType: 2.
	self serialize: anInteger! !

!MDSerializer methodsFor: 'types' stamp: 'cwp 11/12/2008 21:43'!
serializeSet: aSet
	encoder putType: 18.
	self serialize: aSet size.
	aSet do: [:ea | self serialize: ea]! !

!MDSerializer methodsFor: 'types' stamp: 'cwp 11/12/2008 20:39'!
serializeSingleton: anObject
	encoder putSingleton: anObject! !

!MDSerializer methodsFor: 'types' stamp: 'cwp 11/12/2008 20:29'!
serializeSmallNegativeInteger: anInteger 
	encoder putType: 11.
	encoder putSmallInteger: anInteger abs.
	! !

!MDSerializer methodsFor: 'types' stamp: 'cwp 11/12/2008 20:31'!
serializeSmallPositiveInteger: anInteger 
	encoder putType: 10.
	encoder putSmallInteger: anInteger.
	! !

!MDSerializer methodsFor: 'types' stamp: 'cwp 11/12/2008 21:11'!
serializeSymbol: aSymbol
	encoder putType: 14.
	self serialize: aSymbol size.
	encoder putUtf8String: aSymbol! !

!MDSerializer methodsFor: 'types' stamp: 'cwp 11/12/2008 22:11'!
serializeTimestamp: aTimestamp
	encoder putType: 21.
	encoder putBytesFrom: aTimestamp! !

!MDSerializer methodsFor: 'types' stamp: 'cwp 11/12/2008 20:51'!
serializeUtf16String: aString
	encoder putType: 16.
	self serialize: aString size.
	encoder putUtf16String: aString! !

!MDSerializer methodsFor: 'types' stamp: 'cwp 11/12/2008 20:51'!
serializeUtf8String: aString
	encoder putType: 15.
	self serialize: aString size.
	encoder putUtf8String: aString! !

!MDSerializer methodsFor: 'private' stamp: 'cwp 9/2/2008 07:23'!
writeLargeInteger: anInteger type: type 
	| size |
	encoder putType: type.
	size := (anInteger log: 256) floor + 1.
	self serialize: size.
	encoder putLargeInteger: anInteger size: size.
	^ self! !

!MDSerializer methodsFor: 'private' stamp: 'cwp 11/12/2008 22:02'!
writePointersFrom: anObject 
	1	to: anObject size
		do: [ :i | self serialize: (anObject at: i) ]! !

MDObject subclass: #MDTimestampPrinter
	instanceVariableNames: 'year month day hours minutes seconds'
	classVariableNames: 'MDMap MDMonthNames'
	poolDictionaries: ''
	category: 'MC2-Core-Utilities'!

!MDTimestampPrinter commentStamp: 'cwp 4/9/2005 04:06' prior: 0!
%V - If the week containing 1 January has four or more days in the new year, then it is considered week 1. Otherwise, it is the last week of the previous year, and the next week is week 1.
%W - the week number of the year (Monday as the first day of the week) as a decimal number [00,53]. All days in a new year preceding the first Monday are considered to be in week 0.!

!MDTimestampPrinter class methodsFor: 'class initialization' stamp: 'cwp 10/2/2008 20:15'!
initialize
	MDMonthNames := #(
		#January
		#February
		#March
		#April
		#May
		#June
		#July
		#August
		#September
		#Ocober
		#November
		#December
	).
	MDMap := Dictionary new.
	MDMap
		at: $a
			put: #abbreviatedWeekdayName:;
		at: $A
			put: #fullWeekdayName:;
		at: $b
			put: #abbreviatedMonthName:;
		at: $B
			put: #fullMonthName:;
		at: $C
			put: #centuryNumber:;
		at: $d
			put: #paddedDay:;
		at: $D
			put: #usDate:;
		at: $e
			put: #unpaddedDay:;
		at: $h
			put: #unpaddedHour24;
		at: $H
			put: #paddedHour24:;
		at: $i
			put: #unpaddedHour12:;
		at: $I
			put: #paddedHour12:;
		at: $j
			put: #dayOfYear:;
		at: $l
			put: #unpaddedMonth:;
		at: $m
			put: #paddedMonth:;
		at: $M
			put: #paddedMinute:;
		at: $n
			put: #newline:;
		at: $p
			put: #ampm:;
		at: $S
			put: #paddedSecond:;
		at: $t
			put: #tab:;
		at: $u
			put: #weekDayMonday:;
		at: $U
			put: #weekNumberSunday:;
		at: $V
			put: #weekNumberMonday:;
		at: $w
			put: #weekDaySunday:;
		at: $W
			put: #weekNumberMonday2:;
		at: $y
			put: #yearShort:;
		at: $Y
			put: #yearLong:;
		at: $%
			put: #percent:! !

!MDTimestampPrinter class methodsFor: 'instance creation' stamp: 'cwp 4/9/2005 03:03'!
year: year month: month day: day hours: hours minutes: minutes seconds: seconds
	^ self new
		year: year;
		month: month;
		day: day;
		hours: hours;
		minutes: minutes;
		seconds: seconds;
		yourself! !

!MDTimestampPrinter methodsFor: 'specifiers' stamp: 'cwp 10/2/2008 20:15'!
abbreviatedMonthName: aStream 
	aStream nextPutAll: ((MDMonthNames at: month) first: 3)! !

!MDTimestampPrinter methodsFor: 'specifiers' stamp: 'cwp 4/9/2005 04:22'!
ampm: aStream
	aStream nextPutAll: (hours > 12 ifFalse: ['am'] ifTrue: ['pm'])! !

!MDTimestampPrinter methodsFor: 'accessing' stamp: 'cwp 4/9/2005 03:07'!
day
	^day! !

!MDTimestampPrinter methodsFor: 'accessing' stamp: 'cwp 4/9/2005 03:07'!
day: anObject
	day := anObject! !

!MDTimestampPrinter methodsFor: 'errors' stamp: 'cwp 10/2/2008 20:15'!
doesNotUnderstand: aMessage 
	(MDMap values includes: aMessage selector) ifTrue: [ self error: 'Unimplemented specifier' ].
	^ super doesNotUnderstand: aMessage! !

!MDTimestampPrinter methodsFor: 'specifiers' stamp: 'cwp 10/2/2008 20:15'!
fullMonthName: aStream 
	aStream nextPutAll: (MDMonthNames at: month)! !

!MDTimestampPrinter methodsFor: 'private' stamp: 'cwp 5/22/2008 00:10'!
hour12
	| int |
	int := hours \\ 12.
	int = 0 ifTrue: [int := 12].
	^ int! !

!MDTimestampPrinter methodsFor: 'accessing' stamp: 'cwp 4/9/2005 03:00'!
hours
	^hours! !

!MDTimestampPrinter methodsFor: 'accessing' stamp: 'cwp 4/9/2005 03:00'!
hours: anObject
	hours := anObject! !

!MDTimestampPrinter methodsFor: 'accessing' stamp: 'cwp 4/9/2005 03:00'!
minutes
	^minutes! !

!MDTimestampPrinter methodsFor: 'accessing' stamp: 'cwp 4/9/2005 03:00'!
minutes: anObject
	minutes := anObject! !

!MDTimestampPrinter methodsFor: 'accessing' stamp: 'cwp 4/9/2005 03:00'!
month
	^month! !

!MDTimestampPrinter methodsFor: 'accessing' stamp: 'cwp 4/9/2005 03:00'!
month: anObject
	month := anObject! !

!MDTimestampPrinter methodsFor: 'private' stamp: 'cwp 4/9/2005 03:52'!
pad: anInteger on: aStream
	anInteger < 10 ifTrue: [aStream nextPut: $0]! !

!MDTimestampPrinter methodsFor: 'specifiers' stamp: 'cwp 4/9/2005 03:52'!
paddedDay: aStream
	self pad: day on: aStream.
	self unpaddedDay: aStream! !

!MDTimestampPrinter methodsFor: 'specifiers' stamp: 'cwp 5/22/2008 00:10'!
paddedHour12: aStream
	| int |
	int := self hour12.
	self pad: int on: aStream.
	int printOn: aStream! !

!MDTimestampPrinter methodsFor: 'specifiers' stamp: 'cwp 4/9/2005 03:58'!
paddedHour24: aStream
	self pad: hours on: aStream.
	hours printOn: aStream! !

!MDTimestampPrinter methodsFor: 'specifiers' stamp: 'cwp 4/9/2005 03:57'!
paddedMinute: aStream
	self pad: minutes on: aStream.
	minutes printOn: aStream! !

!MDTimestampPrinter methodsFor: 'specifiers' stamp: 'cwp 4/9/2005 03:51'!
paddedMonth: aStream
	self pad: month on: aStream.
	self unpaddedMonth: aStream! !

!MDTimestampPrinter methodsFor: 'specifiers' stamp: 'cwp 4/9/2005 04:21'!
paddedSecond: aStream
	self pad: seconds on: aStream.
	seconds printOn: aStream! !

!MDTimestampPrinter methodsFor: 'printing' stamp: 'cwp 5/22/2008 00:10'!
printFormat: aString
	| stream |
	stream := (String new: 10) writeStream.
	self printOn: stream format: aString.
	^ stream contents! !

!MDTimestampPrinter methodsFor: 'printing' stamp: 'cwp 5/22/2008 00:10'!
printOn: aStream format: aString
	| specification char |
	specification := aString readStream.
	[specification atEnd]	 whileFalse: 
		[char := specification next.
		char = $%
			ifTrue: [self printOn: aStream specifier: specification next]
			ifFalse: [aStream nextPut: char]]! !

!MDTimestampPrinter methodsFor: 'printing' stamp: 'cwp 10/2/2008 20:15'!
printOn: aStream specifier: aCharacter 
	| selector |
	selector := MDMap 
		at: aCharacter
		ifAbsent: [ self error: 'Unrecognized specifier: ' , aCharacter ].
	self 
		perform: selector
		with: aStream! !

!MDTimestampPrinter methodsFor: 'accessing' stamp: 'cwp 4/9/2005 03:01'!
seconds
	^seconds! !

!MDTimestampPrinter methodsFor: 'accessing' stamp: 'cwp 4/9/2005 03:01'!
seconds: anObject
	seconds := anObject! !

!MDTimestampPrinter methodsFor: 'specifiers' stamp: 'cwp 4/9/2005 03:52'!
unpaddedDay: aStream
	day printOn: aStream! !

!MDTimestampPrinter methodsFor: 'specifiers' stamp: 'cwp 4/9/2005 04:20'!
unpaddedHour12: aStream
	self hour12 printOn: aStream! !

!MDTimestampPrinter methodsFor: 'specifiers' stamp: 'cwp 4/9/2005 03:47'!
unpaddedMonth: aStream
	month printOn: aStream! !

!MDTimestampPrinter methodsFor: 'specifiers' stamp: 'cwp 4/9/2005 04:08'!
weekNumberMonday
	"From the Unix spec: 'If the week containing 1 January has four or more days
	in the new year, then it is considered week 1. Otherwise, it is the last week of
	the previous year, and the next week is week 1.'"

	self error: 'Unimplemented Specifier'! !

!MDTimestampPrinter methodsFor: 'specifiers' stamp: 'cwp 4/9/2005 04:08'!
weekNumberMonday2
	"From the Unix spec: 'If the week containing 1 January has four or more days in the new year, 
	then it is considered week 1. Otherwise, it is the last week of the previous year, 
	and the next week is week 1.'"

	self error: 'Unimplemented Specifier'! !

!MDTimestampPrinter methodsFor: 'accessing' stamp: 'cwp 4/9/2005 03:00'!
year
	^year! !

!MDTimestampPrinter methodsFor: 'accessing' stamp: 'cwp 4/9/2005 03:00'!
year: anObject
	year := anObject! !

!MDTimestampPrinter methodsFor: 'specifiers' stamp: 'cwp 4/9/2005 03:53'!
yearLong: aStream
	year printOn: aStream! !

MDObject subclass: #MDVariant
	instanceVariableNames: 'element'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Domain'!

!MDVariant commentStamp: 'dc 6/14/2007 06:15' prior: 0!
A variant describes the state of a particular element. That state might be "not present in the image," in the case of a RemovalVariant, or the properties of the element, in the case of a DefinitionVariant. One of the things that we noticed with MC1 is that the exact components of a definition are most likely to change, so we encode them using a PropertyDictionary instead of dedicated objects.!

MDVariant subclass: #MDDefinitionVariant
	instanceVariableNames: 'properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Domain'!

!MDDefinitionVariant commentStamp: 'dc 6/14/2007 06:28' prior: 0!
A variant describes the state of a particular element. That state is the properties of the element, in the case of this class. One of the things that we noticed with MC1 is that the exact components of a definition are most likely to change, so we encode them using a PropertyDictionary instead of dedicated objects.!

!MDDefinitionVariant methodsFor: 'comparing' stamp: 'dc 6/14/2007 06:21'!
= other
	^ super = other
		and: [self properties = other properties]! !

!MDDefinitionVariant methodsFor: 'conflicts' stamp: 'jf 10/4/2009 20:21'!
autoMergeWith: aVariant in: aDomain 
	^aVariant autoMergeWithDefinition: self in: aDomain! !

!MDDefinitionVariant methodsFor: 'conflicts' stamp: 'jf 10/4/2009 20:21'!
autoMergeWithDefinition: anElementDefinition in: aDomain
	| newDefinition |
	newDefinition := self copy.
	element
		merge: anElementDefinition properties
		into: newDefinition properties
		in: aDomain
		onFailure: [^ nil].
	^ newDefinition! !

!MDDefinitionVariant methodsFor: 'conflicts' stamp: 'jf 10/4/2009 20:21'!
autoMergeWithRemoval: aRemovalVariant in: aDomain 
	element alwaysPreferRemoval ifTrue: [^aRemovalVariant].
	element alwaysPreferDefinition ifTrue: [^self].
	^nil! !

!MDDefinitionVariant methodsFor: 'copying' stamp: 'dc 6/14/2007 06:23'!
copy
	| new |
	new := self species forElement: element.
	properties keysAndValuesDo:
		[:k :v|
		new properties at: k put: v].
	^ new! !

!MDDefinitionVariant methodsFor: 'comparing' stamp: 'dc 6/14/2007 06:22'!
hash
	^ super hash bitXor: self properties hash! !

!MDDefinitionVariant methodsFor: 'initialize-release' stamp: 'dc 6/14/2007 06:18'!
initializeWithElement: anElement
	super initializeWithElement: anElement.
	properties := MDPropertyDictionary new! !

!MDDefinitionVariant methodsFor: 'image proxy' stamp: 'jf 10/4/2009 20:21'!
isLoadableInto: aDomain
	^ element isLoadable: properties into: aDomain! !

!MDDefinitionVariant methodsFor: 'testing' stamp: 'avi 12/2/2004 01:51'!
isRemoval
	^ false! !

!MDDefinitionVariant methodsFor: 'image proxy' stamp: 'jf 10/4/2009 20:21'!
isUpToDateFor: aDomain
	^ (aDomain hasElement: element)
		and: [element is: properties upToDateFor: aDomain]! !

!MDDefinitionVariant methodsFor: 'image proxy' stamp: 'jf 10/4/2009 20:21'!
loadInto: aDomain
	element load: properties into: aDomain! !

!MDDefinitionVariant methodsFor: 'accessing' stamp: 'avi 11/28/2004 16:06'!
properties
	^ properties! !

!MDDefinitionVariant methodsFor: 'image proxy' stamp: 'jf 10/4/2009 20:21'!
updateFrom: aDomain
	(aDomain hasElement: element) ifFalse: [^ MDRemovalVariant forElement: element].
	element update: properties from: aDomain.
	^ self! !

MDVariant subclass: #MDRemovalVariant
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Domain'!

!MDRemovalVariant commentStamp: 'dc 6/14/2007 06:27' prior: 0!
A variant describes the state of a particular element. That state is "not present in the image," in the case of this class.!

!MDRemovalVariant methodsFor: 'conflicts' stamp: 'jf 10/4/2009 20:21'!
autoMergeWith: aVariant in: aDomain 
	^aVariant autoMergeWithRemoval: self in: aDomain! !

!MDRemovalVariant methodsFor: 'conflicts' stamp: 'jf 10/4/2009 20:21'!
autoMergeWithDefinition: anElementDefinition in: aDomain
	^ anElementDefinition autoMergeWithRemoval: self in: aDomain! !

!MDRemovalVariant methodsFor: 'image proxy' stamp: 'jf 10/4/2009 20:21'!
displayFor: aDomain
	^ '-- removed --'! !

!MDRemovalVariant methodsFor: 'image proxy' stamp: 'jf 10/4/2009 20:21'!
isLoadableInto: aDomain
	"Removals are always loadable."
	
	^ true! !

!MDRemovalVariant methodsFor: 'testing' stamp: 'avi 12/2/2004 01:51'!
isRemoval
	^ true! !

!MDRemovalVariant methodsFor: 'testing' stamp: 'jf 10/4/2009 20:21'!
isUpToDateFor: aDomain
	^ (aDomain hasElement: element) not! !

!MDRemovalVariant methodsFor: 'image proxy' stamp: 'jf 10/4/2009 20:21'!
loadInto: aDomain
	element removeFrom: aDomain! !

!MDRemovalVariant methodsFor: 'image proxy' stamp: 'jf 10/4/2009 20:21'!
updateFrom: aDomain
	^ (MDDefinitionVariant forElement: element) updateFrom: aDomain! !

!MDVariant class methodsFor: 'instance creation' stamp: 'jf 11/8/2009 17:38'!
forElement: anElement
	^ self basicNew
		initializeWithElement: anElement;
		yourself! !

!MDVariant class methodsFor: 'instance creation' stamp: 'jf 11/8/2009 19:49'!
forTesting
	^ self forElement: (MDFakeElement named: #alpha)! !

!MDVariant class methodsFor: 'instance creation' stamp: 'jf 11/8/2009 17:38'!
new
	self shouldNotImplement! !

!MDVariant methodsFor: 'comparing' stamp: 'dc 6/14/2007 06:21'!
= other
	^ self species = other species
		and: [self element = other element]! !

!MDVariant methodsFor: 'accessing' stamp: 'cwp 10/16/2005 14:43'!
element
	^ element! !

!MDVariant methodsFor: 'comparing' stamp: 'dc 6/14/2007 06:20'!
hash
	^ element hash! !

!MDVariant methodsFor: 'initialize-release' stamp: 'jf 11/8/2009 16:58'!
initializeWithElement: anImageElement
	self initialize.
	element := anImageElement! !

!MDVariant methodsFor: 'converting' stamp: 'dc 6/21/2007 18:32'!
newElementVersion
	"Creates a new version based on the receiver."
	^ MDElementVersion variant: self! !

MDObject subclass: #MDVersionedObject
	instanceVariableNames: 'id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Utilities'!

MDVersionedObject subclass: #MDProject
	instanceVariableNames: 'name slices repositories announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Environment'!

!MDProject class methodsFor: 'instance creation' stamp: 'cwp 9/4/2009 15:57'!
forTesting
	^ self named: 'Test Project'! !

!MDProject class methodsFor: 'instance creation' stamp: 'cwp 1/18/2010 21:22'!
id: aHashstamp name: aString
	^ self basicNew initializeWithId: aHashstamp name: aString! !

!MDProject class methodsFor: 'instance creation' stamp: 'cwp 1/18/2010 21:22'!
named: aString
	^ self id: MDHashstamp new name: aString! !

!MDProject methodsFor: 'accessing' stamp: 'jf 11/25/2009 15:57'!
addRepository: aRepository 
	repositories register: aRepository.
	self announce: (MDRepositoryAssociated project: self repository: aRepository).
	^ aRepository! !

!MDProject methodsFor: 'accessing' stamp: 'jf 11/25/2009 16:02'!
addSlice: aSlice 
	slices register: aSlice.
	self announce: (MDSliceAssociated project: self slice: aSlice).
	^ aSlice! !

!MDProject methodsFor: 'announcing' stamp: 'jf 11/19/2009 16:15'!
announce: anObject
	self announcer announce: anObject! !

!MDProject methodsFor: 'announcing' stamp: 'cwp 11/25/2009 15:00'!
announcer
	^ announcer! !

!MDProject methodsFor: 'initialize-release' stamp: 'cwp 1/18/2010 21:20'!
initializeWithId: aHashstamp name: aString
	self initializeWithId: aHashstamp.
	name := aString.
	announcer := MDAnnouncer new.
	slices := MDRegistry new.
	repositories := MDRegistry new! !

!MDProject methodsFor: 'accessing' stamp: 'cwp 5/31/2008 14:34'!
name
	^ name ! !

!MDProject methodsFor: 'accessing' stamp: 'jf 11/25/2009 16:05'!
name: aString
	name := aString.
	self announce: (MDProjectRenamed project: self)! !

!MDProject methodsFor: 'accessing' stamp: 'jf 11/25/2009 16:05'!
removeRepository: aRepository 
	| repository |
	repository := repositories unregister: aRepository ifAbsent: [^ nil].
	self announce: (MDRepositoryDissociated project: self repository: repository).
	^ repository! !

!MDProject methodsFor: 'accessing' stamp: 'jf 11/25/2009 16:06'!
removeSlice: aSlice 
	| slice |
	slice := slices unregister: aSlice ifAbsent: [^ nil].
	self announce: (MDSliceDissociated project: self slice: slice).
	^ slice! !

!MDProject methodsFor: 'accessing' stamp: 'cwp 8/18/2009 01:50'!
repositories
	^ repositories objects! !

!MDProject methodsFor: 'initialize-release' stamp: 'jf 11/8/2009 17:05'!
setName: aString
	name := aString! !

!MDProject methodsFor: 'accessing' stamp: 'cwp 8/18/2009 01:50'!
slices
	^ slices objects! !

MDVersionedObject subclass: #MDRepository
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Repositories'!

!MDRepository commentStamp: 'dc 6/14/2007 06:45' prior: 0!
Repositories are similar to those in MC1, but have a different protocol and different performance characteristics. Conceptually, repositories are dictionaries, mapping hashstamps to versions or snapshots. This makes for a very fine-grained protocol - versions are loaded individually. That makes directory or HTTP repositories impractical, since loading a slice for a medium-size package would involve opening and reading hundreds of files. (A snapshot of OB, for example runs at over 600 versions).!

MDRepository subclass: #MDMemoryRepository
	instanceVariableNames: 'name objects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Repositories'!

!MDMemoryRepository class methodsFor: 'instance creation' stamp: 'cwp 1/18/2010 21:55'!
forTesting
	^ self named: 'TestMemoryRepository'! !

!MDMemoryRepository class methodsFor: 'instance creation' stamp: 'cwp 1/18/2010 21:55'!
id: aHashstamp name: aString
	^ self basicNew initializeWithId: aHashstamp name: aString! !

!MDMemoryRepository class methodsFor: 'instance creation' stamp: 'cwp 1/18/2010 21:56'!
named: aString
	^ self id: MDHashstamp new name: aString! !

!MDMemoryRepository methodsFor: 'synchronization' stamp: 'cwp 8/9/2009 13:12'!
allHashstamps
	^ objects keys! !

!MDMemoryRepository methodsFor: 'converting' stamp: 'cwp 10/17/2009 23:22'!
elementClass
	^ MDMemoryRepositoryElement! !

!MDMemoryRepository methodsFor: 'public' stamp: 'cwp 8/9/2009 13:12'!
get: aHashstamp 
	^ objects 
		at: aHashstamp
		ifAbsent: [ nil ]! !

!MDMemoryRepository methodsFor: 'synchronization' stamp: 'cwp 8/9/2009 13:12'!
includes: aHashstamp 
	^ objects includesKey: aHashstamp! !

!MDMemoryRepository methodsFor: 'initialize-release' stamp: 'cwp 1/18/2010 21:56'!
initializeWithId: aHashstamp name: aString
	self initializeWithId: aHashstamp.
	name := aString.
	objects := Dictionary new.
! !

!MDMemoryRepository methodsFor: 'public' stamp: 'cwp 8/9/2009 13:12'!
memos
	^ objects values select: [ :ea | ea isMemo ]! !

!MDMemoryRepository methodsFor: 'accessing' stamp: 'cwp 5/31/2008 14:41'!
name
	^ name! !

!MDMemoryRepository methodsFor: 'accessing' stamp: 'cwp 10/21/2009 23:39'!
name: aString
	name := aString! !

!MDMemoryRepository methodsFor: 'accessing' stamp: 'cwp 8/9/2009 13:12'!
objects
	^ objects! !

!MDMemoryRepository methodsFor: 'public' stamp: 'cwp 8/9/2009 13:12'!
put: anElementVersion 
	objects 
		at: anElementVersion hashstamp
		put: anElementVersion! !

!MDMemoryRepository methodsFor: 'accessing' stamp: 'cwp 8/9/2009 13:13'!
versions
	^ objects select: [:ea | ea isKindOf: MDElementVersion]! !

!MDRepository methodsFor: 'synchronization' stamp: 'cwp 12/22/2007 23:45'!
allHashstamps
	self subclassResponsibility ! !

!MDRepository methodsFor: 'converting' stamp: 'cwp 10/17/2009 23:21'!
asElement
	^ self elementClass for: self ! !

!MDRepository methodsFor: 'public' stamp: 'cwp 12/29/2006 18:02'!
close
! !

!MDRepository methodsFor: 'public' stamp: 'cwp 5/31/2008 14:41'!
description
	^ self name! !

!MDRepository methodsFor: 'public' stamp: 'cwp 10/22/2009 12:13'!
destroy
	self close.
	
	"Subclasses should perform additional cleanup after calling this implementation."! !

!MDRepository methodsFor: 'converting' stamp: 'cwp 10/17/2009 23:21'!
elementClass
	self subclassResponsibility ! !

!MDRepository methodsFor: 'public' stamp: 'dc 6/14/2007 07:17'!
get: aHashstamp 
	self subclassResponsibility ! !

!MDRepository methodsFor: 'public' stamp: 'cwp 5/22/2008 00:10'!
getAll: aSet
	| result |
	result := Set new.
	aSet do: [:hashstamp | (self get: hashstamp) ifNotNilDo: [:obj | result add: obj]].
	^ result! !

!MDRepository methodsFor: 'synchronization' stamp: 'cwp 12/22/2007 23:48'!
includes: aHashstamp
	self subclassResponsibility! !

!MDRepository methodsFor: 'public' stamp: 'dc 6/14/2007 07:17'!
memos
	self subclassResponsibility ! !

!MDRepository methodsFor: 'synchronization' stamp: 'cwp 5/22/2008 00:10'!
pushTo: aRepository
	| wanted |
	wanted := aRepository selectFrom: self allHashstamps.
	aRepository putAll: (wanted collect: [:ea | self get: ea])! !

!MDRepository methodsFor: 'public' stamp: 'dc 6/14/2007 07:17'!
put: aHashedObject
	self subclassResponsibility ! !

!MDRepository methodsFor: 'public' stamp: 'cwp 12/22/2007 22:26'!
putAll: aSet
	aSet do: [:ea | self put: ea]! !

!MDRepository methodsFor: 'synchronization' stamp: 'cwp 12/22/2007 23:49'!
selectFrom: aSet
	^ aSet reject: [:ea | self includes: ea]! !

!MDRepository methodsFor: 'synchronization' stamp: 'cwp 12/22/2007 23:53'!
synchronizeWith: aRepository
	self pushTo: aRepository.
	aRepository pushTo: self! !

!MDRepository methodsFor: 'accessing' stamp: 'jf 10/21/2009 15:34'!
update: properties
	^ properties
		name: self name;
		yourself! !

MDVersionedObject subclass: #MDSlice
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Slices'!

!MDSlice commentStamp: 'dc 6/14/2007 07:32' prior: 0!
A slice is sub-set of the elements in the image. It's main responsibility is to define which elements are part of the slice and which are not. Slices can be based on any set of criteria - PackageInfo, ChangeSets, an explicit collection, whatever. Slices can overlap. Elements can belong to more than one slice at the same time.!

MDSlice subclass: #MDExplicitSlice
	instanceVariableNames: 'name elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Slices'!

!MDExplicitSlice class methodsFor: 'converting' stamp: 'cwp 9/12/2009 11:36'!
elementClass
	^ MDExplicitSliceElement! !

!MDExplicitSlice class methodsFor: 'instance creation' stamp: 'cwp 6/7/2008 13:46'!
forTesting
	^ self named: 'TestSlice'! !

!MDExplicitSlice class methodsFor: 'instance creation' stamp: 'cwp 1/18/2010 22:05'!
id: aHashstamp name: aString elements: aCollection
	^ self basicNew
		initializeWithId: aHashstamp name: aString elements: aCollection! !

!MDExplicitSlice class methodsFor: 'instance creation' stamp: 'jf 11/8/2009 18:10'!
named: aString
	^ self named: aString elements: Set new! !

!MDExplicitSlice class methodsFor: 'instance creation' stamp: 'cwp 1/18/2010 22:05'!
named: aString elements: aCollection
	^ self id: MDHashstamp new name: aString elements: aCollection! !

!MDExplicitSlice methodsFor: 'accessing' stamp: 'cwp 2/27/2005 18:54'!
addElement: anElement
	elements add: anElement! !

!MDExplicitSlice methodsFor: 'accessing' stamp: 'jf 10/21/2009 14:52'!
elements
	^ elements! !

!MDExplicitSlice methodsFor: 'enumerating' stamp: 'cwp 1/18/2007 23:59'!
elementsDo: aBlock
	elements do: aBlock.! !

!MDExplicitSlice methodsFor: 'testing' stamp: 'cwp 8/28/2005 23:34'!
includes: anElement
	^ elements includes: anElement! !

!MDExplicitSlice methodsFor: 'initialize-release' stamp: 'cwp 1/18/2010 22:04'!
initializeWithId: aHashstamp name: aString elements: aCollection
	self initializeWithId: aHashstamp.
	name := aString.
	elements := aCollection asSet! !

!MDExplicitSlice methodsFor: 'accessing' stamp: 'cwp 3/15/2005 22:26'!
name
	^ name! !

!MDSlice class methodsFor: 'converting' stamp: 'cwp 9/12/2009 11:33'!
elementClass
	self subclassResponsibility! !

!MDSlice methodsFor: 'converting' stamp: 'cwp 9/12/2009 11:33'!
asElement
	^ self class elementClass id: self id! !

!MDSlice methodsFor: 'converting' stamp: 'cwp 1/18/2010 22:12'!
asExplicitSlice
	^ MDExplicitSlice 
		named: self name 
		elements: self elements! !

!MDSlice methodsFor: 'private' stamp: 'jf 9/8/2009 16:29'!
basicLoad: aSnapshot from: aRepository to: aWorkspace
	| versions expanded |
	versions := aSnapshot getVersionsFrom: aRepository for: aWorkspace.
	expanded := self expandVersions: versions.
	aWorkspace transaction: 
		[expanded do: [:ea | aWorkspace loadVersion: ea]]! !

!MDSlice methodsFor: 'private' stamp: 'jf 9/8/2009 16:29'!
basicSaveFrom: aWorkspace to: aRepository memo: aMemo
	| objects snapshot |
	objects := Set new.	
	self do: [:ea | objects add: (aWorkspace versionForElement: ea)].
	snapshot := MDSnapshot withVersions: objects.
	objects add: snapshot.
	aMemo ifNotNil: 
		[aMemo setSnapshot: snapshot slice: self.
		objects add: aMemo].
	aRepository putAll: objects.
	^ snapshot! !

!MDSlice methodsFor: 'enumerating' stamp: 'cwp 5/7/2008 07:42'!
do: aBlock
	self elementsDo: aBlock! !

!MDSlice methodsFor: 'accessing' stamp: 'dc 6/14/2007 07:41'!
elements
	| result |
	result := Set new.
	self do: [:ea | result add: ea].
	^ result! !

!MDSlice methodsFor: 'enumerating' stamp: 'jf 10/4/2009 21:07'!
elementsDo: aBlock
	"Evaluate aBlock once for every element that is currently present and
	included in the receiving Slice."! !

!MDSlice methodsFor: 'private' stamp: 'dc 6/14/2007 07:44'!
expandVersions: versions
	| existingElements result |
	existingElements := versions collect: [:ea | ea element]. 
	result := versions copy.
	self do: [:el | (existingElements includes: el) 
					ifFalse: [result add: (MDNullVersion forElement: el)]].
	^ result! !

!MDSlice methodsFor: 'public' stamp: 'jf 9/8/2009 16:29'!
include: aSnapshot from: aRepository in: aWorkspace
	| versions |
	MDPlatform current 
		withCursor: #read 
		do: [versions := aSnapshot getVersionsFrom: aRepository for: aWorkspace].
	MDMergeRequest
		includeAll: (self expandVersions: versions)
		in: aWorkspace! !

!MDSlice methodsFor: 'testing' stamp: 'cwp 10/16/2009 21:32'!
includes: anElement
	self subclassResponsibility! !

!MDSlice methodsFor: 'public' stamp: 'jf 9/8/2009 16:29'!
load: aSnapshot from: aRepository to: aWorkspace
	
	MDPlatform current 
		withCursor: #read 
		do: [self basicLoad: aSnapshot from: aRepository to: aWorkspace]! !

!MDSlice methodsFor: 'public' stamp: 'jf 9/8/2009 16:29'!
saveFrom: aWorkspace to: aRepository memo: aMemo
	^ MDPlatform current 
		withCursor: #write 
		do: [self basicSaveFrom: aWorkspace to: aRepository memo: aMemo].
	! !

!MDSlice methodsFor: 'private' stamp: 'cwp 11/16/2007 00:55'!
withCursor: aSymbol do: aBlock
	MDPlatform current showCursor: aSymbol.
	aBlock ensure: [MDPlatform current showCursor: nil]! !

MDSlice subclass: #MDUnionSlice
	instanceVariableNames: 'name slices'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Slices'!

!MDUnionSlice class methodsFor: 'converting' stamp: 'cwp 9/12/2009 12:31'!
elementClass
	^ MDUnionSliceElement! !

!MDUnionSlice class methodsFor: 'instance creation' stamp: 'cwp 1/18/2010 22:21'!
forTesting
	^ self name: 'TestUnionSlice'! !

!MDUnionSlice class methodsFor: 'instance creation' stamp: 'cwp 1/18/2010 22:20'!
id: aHashstamp name: aString slices: aCollection
	^ self basicNew initializeWithId: aHashstamp name: aString slices: aCollection! !

!MDUnionSlice class methodsFor: 'instance creation' stamp: 'cwp 5/29/2008 08:00'!
name: aString
	^ self name: aString slices: Set new! !

!MDUnionSlice class methodsFor: 'instance creation' stamp: 'cwp 1/18/2010 22:20'!
name: aString slices: aCollection
	^ self id: MDHashstamp new name: aString slices: aCollection! !

!MDUnionSlice methodsFor: 'accessing' stamp: 'jf 10/21/2009 16:38'!
addSlice: aSlice
	^ slices add: aSlice! !

!MDUnionSlice methodsFor: 'enumerating' stamp: 'cwp 5/22/2008 00:10'!
elementsDo: aBlock
	| done |
	done := Set new.
	slices do:
		[:slice |
		slice elementsDo:
			[:element |
			(done includes: element) ifFalse:
				[aBlock value: element.
				done add: element]]]! !

!MDUnionSlice methodsFor: 'testing' stamp: 'cwp 2/3/2008 20:47'!
includes: anElement
	^ slices anySatisfy: [:ea | ea includes: anElement]! !

!MDUnionSlice methodsFor: 'accessing' stamp: 'cwp 6/14/2008 17:47'!
includesSlice: aSlice
	^ slices includes: aSlice! !

!MDUnionSlice methodsFor: 'initialize-release' stamp: 'cwp 1/18/2010 22:18'!
initializeWithId: aHashstamp name: aString slices: aCollection
	self initializeWithId: aHashstamp.
	name := aString.
	slices := aCollection asSet! !

!MDUnionSlice methodsFor: 'accessing' stamp: 'cwp 5/29/2008 08:00'!
name
	^ name! !

!MDUnionSlice methodsFor: 'accessing' stamp: 'jf 10/16/2009 21:59'!
removeSlice: aSlice
	slices remove: aSlice! !

!MDUnionSlice methodsFor: 'accessing' stamp: 'jf 10/21/2009 15:08'!
slices
	^ slices! !

!MDVersionedObject class methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2010 22:33'!
new
	self shouldNotImplement! !

!MDVersionedObject methodsFor: 'comparing' stamp: 'cwp 5/31/2008 14:17'!
= other 
	^ id = other id! !

!MDVersionedObject methodsFor: 'comparing' stamp: 'cwp 5/31/2008 14:14'!
hash
	^ id hash! !

!MDVersionedObject methodsFor: 'accessing' stamp: 'cwp 5/31/2008 14:13'!
id
	^ id! !

!MDVersionedObject methodsFor: 'initialize-release' stamp: 'cwp 1/18/2010 21:30'!
initializeWithId: aHashstamp
	self initialize.
	id := aHashstamp! !

!MDVersionedObject methodsFor: 'accessing' stamp: 'cwp 5/31/2008 14:26'!
name
	^ self subclassResponsibility! !

!MDVersionedObject methodsFor: 'initialize-release' stamp: 'cwp 5/31/2008 14:14'!
setId: aHashstamp
	id := aHashstamp! !

!MDVersionedObject methodsFor: 'accessing' stamp: 'cwp 5/31/2008 18:25'!
timestamp
	^ nil! !

MDObject subclass: #MDWorkspace
	instanceVariableNames: 'domains versions slush transaction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Versions'!

!MDWorkspace commentStamp: 'dc 6/14/2007 08:30' prior: 0!
I'm not terribly happy with this name, but I can't think of a better one. It keeps track of the state of the image with respect to versioning. It knows, for example, which versions image is based on, and can perform tasks like creating new versions based on the state of the image, or loading existing versions into the image.!

!MDWorkspace class methodsFor: 'instance creation' stamp: 'jf 11/8/2009 18:44'!
forDomain: aDomain 
	^ self new
		domainAt: aDomain name put: aDomain;
		yourself! !

!MDWorkspace class methodsFor: 'instance creation' stamp: 'cwp 5/26/2008 22:01'!
forTesting
	^ self new 
		domainAt: #fake put: MDFakeDomain new;
		yourself! !

!MDWorkspace methodsFor: 'public' stamp: 'cwp 5/26/2008 20:14'!
changeForElement: anElement do: aBlock
	| version variant domain |
	domain := self domainForElement: anElement.
	version := versions 
		at: anElement 
		ifAbsent: [MDNullVersion forElement: anElement].
	^ (domain isUpToDate: version variant) ifFalse:
		[variant := domain updateVariant: version variant copy.
		aBlock value: (MDChange version: version variant: variant)]! !

!MDWorkspace methodsFor: 'public' stamp: 'cwp 8/3/2008 20:58'!
changeFromVersion: aVersion do: aBlock 
	| variant domain |
	domain := self domainForElement: aVersion element.
	(domain isUpToDate: aVersion variant) ifFalse:
		[variant := domain updateVariant: aVersion variant copy.
		aBlock value: (MDChange version: aVersion variant: variant) ]! !

!MDWorkspace methodsFor: 'private' stamp: 'cwp 5/26/2008 20:10'!
createVersionForElement: anElement 
	| variant version domain |
	domain := self domainForElement: anElement.
	(domain hasElement: anElement) 
		ifFalse: [^MDNullVersion forElement: anElement].
	variant := (MDDefinitionVariant forElement: anElement) updateFrom: domain.
	version := MDElementVersion variant: variant.
	versions at: anElement put: version.
	^version! !

!MDWorkspace methodsFor: 'private' stamp: 'cwp 5/26/2008 21:40'!
domainAt: index in: aCollection transaction: aBlock
	^ (aCollection size < index) 
		ifTrue: aBlock
		ifFalse: 
			[(aCollection at: index) transaction: 
				[self domainAt: index + 1 in: aCollection transaction: aBlock]]! !

!MDWorkspace methodsFor: 'public' stamp: 'jf 10/21/2009 16:39'!
domainAt: aSymbol put: aDomain
	^ domains at: aSymbol put: aDomain! !

!MDWorkspace methodsFor: 'private' stamp: 'cwp 6/17/2008 00:10'!
domainForElement: anElement
	^ domains 
		at: anElement domain
		ifAbsentPut: [MDDomain defaultForType: anElement domain]! !

!MDWorkspace methodsFor: 'private' stamp: 'cwp 10/17/2005 08:31'!
ensureTransactionDuring: aBlock
	^ transaction
		ifNil: [self transaction: aBlock]
		ifNotNil: [aBlock value]! !

!MDWorkspace methodsFor: 'public' stamp: 'cwp 5/26/2008 23:26'!
hasDomainNamed: aSymbol
	^ domains includesKey: aSymbol! !

!MDWorkspace methodsFor: 'public' stamp: 'cwp 5/26/2008 20:07'!
includeVersion: anElementVersion onConflict: twoArgBlock 
	| current successor element domain |
	element := anElementVersion element.
	current := self versionForElement: element.
	domain := self domainForElement: element.
	successor := current 
		successor: anElementVersion
		onConflict: 
			[ current 
				resolveConflictWith: anElementVersion
				in: domain
				using: twoArgBlock ].
	successor == current ifTrue: [ ^ false ].
	self loadVersion: successor.
	^ true! !

!MDWorkspace methodsFor: 'initialize-release' stamp: 'jf 11/8/2009 18:44'!
initialize
	super initialize.
	domains := Dictionary new.
	versions := Dictionary new.
	slush := Set new.! !

!MDWorkspace methodsFor: 'private' stamp: 'dc 7/4/2007 16:38'!
loadSlush
	"Tries to load all versions in slush. Keeps trying until nothing is loadable anymore."
	[| oldSize 
	 |oldSize := slush size.
	 slush := self loadSlush: slush.
	 slush size ~= oldSize] whileTrue.
	! !

!MDWorkspace methodsFor: 'private' stamp: 'cwp 5/26/2008 21:44'!
loadSlush: elementVersions 
	"Tries to load all element versions in the parameter. Collect all versions that can't be loaded and return them."
	| unloadable domain |
	unloadable := Set new.
	elementVersions do: 
		[:ea | 
		domain := self domainForElement: ea element.
		(domain isLoadable: ea variant) 
			ifTrue: [domain loadVariant: ea variant]
			ifFalse: [unloadable add: ea]].
	^ unloadable! !

!MDWorkspace methodsFor: 'public' stamp: 'cwp 2/4/2006 20:45'!
loadVersion: anElementVersion

	self ensureTransactionDuring: 
		[versions at: anElementVersion element put: anElementVersion.
		transaction add: anElementVersion]
! !

!MDWorkspace methodsFor: 'private' stamp: 'cwp 5/26/2008 20:04'!
newVersionForElement: anImageElement 
	| oldVersion newVariant domain |
	oldVersion := versions at: anImageElement.
	newVariant := oldVersion variant copy.
	domain := self domainForElement: anImageElement.
	^ versions 
		at: anImageElement
		put: (MDElementVersion 
				variant: (domain updateVariant: newVariant)
				ancestry: oldVersion fullAncestry)! !

!MDWorkspace methodsFor: 'public' stamp: 'cwp 5/26/2008 21:40'!
transaction: aBlock
	| result |
	transaction := OrderedCollection new.
	result := aBlock value.
	slush := transaction, slush asOrderedCollection.
	transaction := nil.
	self domainAt: 1 in: domains asArray transaction: [self loadSlush].
	^ result! !

!MDWorkspace methodsFor: 'public' stamp: 'cwp 5/26/2008 20:02'!
versionForElement: anElement
	| old |
	old := versions 
			at: anElement 
			ifAbsent: [^ self createVersionForElement: anElement].
	^ ((self domainForElement: anElement) isUpToDate: old variant)
		ifTrue: [old]
		ifFalse: [self newVersionForElement: anElement]! !

!MDWorkspace methodsFor: 'public' stamp: 'cwp 12/22/2007 22:10'!
versionForHashstamp: aHashstamp ifPresent: pBlock ifAbsent: aBlock
	versions do: [:ea | ea hashstamp = aHashstamp ifTrue: [^ pBlock value: ea]].
	^ aBlock value! !

!UndefinedObject methodsFor: '*mc2-core-serialization' stamp: 'cwp 11/20/2008 19:18'!
mdSerializeWith: aSerializer 
	^ aSerializer serializeSingleton: self! !

!Dictionary methodsFor: '*mc2-core' stamp: 'cwp 11/20/2008 19:18'!
mdSerializeWith: aSerializer 
	^ aSerializer serializeDictionary: self! !

Dictionary subclass: #MDPropertyDictionary
	instanceVariableNames: 'localReference'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Domain'!

!MDPropertyDictionary commentStamp: 'cwp 5/9/2006 23:27' prior: 0!
I store the state of particular variant of an element. !

!MDPropertyDictionary methodsFor: 'accessing' stamp: 'cwp 4/3/2005 20:33'!
at: key
	^ self at: key ifAbsent: [nil]! !

!MDPropertyDictionary methodsFor: 'accessing' stamp: 'cwp 4/3/2005 20:31'!
at: key put: anObject
	anObject ifNotNil: [super at: key put: anObject]! !

!MDPropertyDictionary methodsFor: 'convenience' stamp: 'cwp 4/3/2005 20:36'!
doesNotUnderstand: aMessage
	aMessage selector isUnary ifTrue: [^ self at: aMessage selector].
	(aMessage selector isKeyword
		and: [aMessage arguments size = 1])
			ifTrue: [^ self
						at: aMessage selector allButLast asSymbol
						put: aMessage arguments first].
	super doesNotUnderstand: aMessage.! !

!MDPropertyDictionary methodsFor: 'accessing' stamp: 'avi 3/14/2005 18:08'!
localReference
	^ localReference! !

!MDPropertyDictionary methodsFor: 'accessing' stamp: 'dc 6/14/2007 06:12'!
localReference: anObject
	localReference := anObject! !

!MDPropertyDictionary methodsFor: 'serialization' stamp: 'cwp 11/20/2008 19:18'!
mdSerializeWith: aSerializer 
	aSerializer serializeProperties: self! !

!MDPropertyDictionary methodsFor: 'convenience' stamp: 'cwp 12/31/2006 01:09'!
name
	^ self at: #name! !

Object subclass: #MDAnnouncer
	instanceVariableNames: 'subscriptions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Announcements'!

!MDAnnouncer commentStamp: 'cwp 7/28/2008 07:06' prior: 0!
This is copied from OmniBrowser. This should be factored out into a separate library that's used by both, but hey, it's only a handful of methods. !

!MDAnnouncer methodsFor: 'subscription' stamp: 'cwp 7/27/2008 20:29'!
announce: anObject

	| ann |
	ann _ anObject asAnnouncement.
	subscriptions keysAndValuesDo:
		[:class :action |
		(ann isKindOf: class) ifTrue: [action valueWithArguments: (Array with: ann)]].
	^ ann! !

!MDAnnouncer methodsFor: 'initialize-release' stamp: 'jf 11/8/2009 16:56'!
initialize
	super initialize.
	subscriptions := IdentityDictionary new.! !

!MDAnnouncer methodsFor: 'subscription' stamp: 'cwp 7/27/2008 20:29'!
observe: aClass do: aValuable 
	| actions |
	actions _ subscriptions at: aClass ifAbsent: [ActionSequence new].
	subscriptions at: aClass put: (actions copyWith: aValuable).! !

!MDAnnouncer methodsFor: 'subscription' stamp: 'cwp 7/27/2008 20:29'!
observe: aClass send: aSelector to: anObject
	self
		observe: aClass
		do: (MessageSend receiver: anObject selector: aSelector)! !

!MDAnnouncer methodsFor: 'accessing' stamp: 'cwp 8/3/2008 22:53'!
subscribers
	^ subscriptions
		inject: IdentitySet new
		into: 
			[:subscribers :actions | 
			actions do: [:ea | subscribers add: ea receiver]. 
			subscribers]! !

!MDAnnouncer methodsFor: 'subscription' stamp: 'cwp 7/27/2008 20:29'!
unsubscribe: anObject
	subscriptions keysAndValuesDo:
		[:class :actions |
		subscriptions at: class put: (actions reject: [:ea | ea receiver == anObject])].
	subscriptions keysAndValuesRemove: [:key :value | value isEmpty]! !

!Object methodsFor: '*mc2-core' stamp: 'cwp 11/20/2008 19:18'!
mdSerializeWith: aSerializer 
	aSerializer serializeObject: self! !

!Integer methodsFor: '*mc2-core' stamp: 'cwp 11/20/2008 19:18'!
mdSerializeWith: aSerializer 
	aSerializer serializeInteger: self! !

!Set methodsFor: '*mc2-core-serialization' stamp: 'cwp 11/20/2008 19:18'!
mdSerializeWith: aSerializer 
	aSerializer serializeSet: self! !

Magnitude variableByteSubclass: #MDHashstamp
	instanceVariableNames: ''
	classVariableNames: 'MDArbitrary MDCharMap'
	poolDictionaries: ''
	category: 'MC2-Core-Versions'!

!MDHashstamp commentStamp: 'dc 6/14/2007 08:17' prior: 0!
A Hashstamp is combination of SHA1 hash and timestamp which uniquely identifies the version.!

!MDHashstamp class methodsFor: 'instance creation' stamp: 'cwp 1/19/2010 21:04'!
basicNew
	^ self basicNew: self hashstampSize! !

!MDHashstamp class methodsFor: 'serializing' stamp: 'cwp 10/2/2008 20:19'!
decodeString: aString 
	| write read a b c d |
	write := (ByteArray new: self hashstampSize) writeStream.
	read := aString readStream.
	[ read atEnd ] whileFalse: 
		[ a := (MDCharMap indexOf: read next) - 1.
		b := (MDCharMap indexOf: read next) - 1.
		write nextPut: (a bitShift: 2) + (b bitShift: -4).
		b := b bitAnd: 15.
		c := (MDCharMap indexOf: read next) - 1.
		write nextPut: (b bitShift: 4) + (c bitShift: -2).
		c := c bitAnd: 3.
		d := (MDCharMap indexOf: read next) - 1.
		write nextPut: (c bitShift: 6) + d ].
	^ write contents! !

!MDHashstamp class methodsFor: 'instance creation' stamp: 'cwp 1/19/2010 21:23'!
fromBytes: aByteArray
	| hashstamp |
	aByteArray size = self hashstampSize ifFalse: [self error: 'Incorrect byte size'].
	hashstamp := self basicNew.
	1 to: 24 do: [:i | hashstamp byteAt: i put: (aByteArray at: i)].
	^ hashstamp! !

!MDHashstamp class methodsFor: 'instance creation' stamp: 'avi 3/14/2005 12:46'!
fromString: aString
	^ self fromBytes: (self decodeString: aString)! !

!MDHashstamp class methodsFor: 'accessing defaults' stamp: 'dc 6/27/2007 13:48'!
hashstampSize
	^ 24! !

!MDHashstamp class methodsFor: 'initialize-release' stamp: 'cwp 8/8/2009 14:48'!
initialize
	MDCharMap := '+-0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz'.
	MDArbitrary := Random seed: (Time millisecondClockValue bitAnd: 16r3FFFFFFF)! !

!MDHashstamp class methodsFor: 'instance creation' stamp: 'cwp 1/19/2010 21:24'!
tag: aByteArray timestamp: aTimestamp
	^ self basicNew setTag: aByteArray timestamp: aTimestamp! !

!MDHashstamp class methodsFor: 'instance creation' stamp: 'cwp 1/19/2010 21:23'!
timestamp: aTimestamp
	| inst |
	inst := self new.
	inst setTag: inst tag timestamp: aTimestamp.
	^ inst! !

!MDHashstamp methodsFor: 'comparing' stamp: 'cwp 5/22/2008 00:10'!
< other
	| selfByte otherByte |
	1 to: self byteSize do: 
		[:i | 
			selfByte := self byteAt: i.
			otherByte := other byteAt: i.
			(selfByte == otherByte) ifFalse: [^ selfByte < otherByte]].
	^ false! !

!MDHashstamp methodsFor: 'comparing' stamp: 'cwp 9/11/2005 17:56'!
= other
	self class = other class ifFalse: [^ false].
	1 to: self size do: [:i | (self at: i) = (other at: i) ifFalse: [^ false]].
	^ true! !

!MDHashstamp methodsFor: 'serializing' stamp: 'cwp 6/23/2008 13:19'!
asByteArray
	^ self bytes! !

!MDHashstamp methodsFor: 'bytes' stamp: 'cwp 4/18/2005 13:17'!
byteAt: index
	^ self basicAt: index! !

!MDHashstamp methodsFor: 'bytes' stamp: 'cwp 4/18/2005 13:41'!
byteAt: index put: value
	self basicAt: index put: value! !

!MDHashstamp methodsFor: 'bytes' stamp: 'cwp 4/18/2005 13:46'!
byteSize
	^ self basicSize! !

!MDHashstamp methodsFor: 'serializing' stamp: 'cwp 5/22/2008 00:10'!
bytes
	| bytes |
	bytes := ByteArray new: self size.
	bytes replaceFrom: 1 to: self size with: self startingAt: 1.
	^ bytes! !

!MDHashstamp methodsFor: 'accessing' stamp: 'cwp 8/8/2009 15:12'!
checkByte
	^ self at: 24! !

!MDHashstamp methodsFor: 'comparing' stamp: 'cwp 4/18/2005 13:35'!
hash
	^ByteArray
		hashBytes: self
		startingWith: self species hash! !

!MDHashstamp methodsFor: 'accessing' stamp: 'cwp 9/6/2009 11:21'!
id
	^ self! !

!MDHashstamp methodsFor: 'initialize-release' stamp: 'cwp 1/19/2010 21:21'!
initialize
	super initialize.
	self replaceFrom: 1 to: 4 with: MDTimestamp now.
	5 to: 23 do:  [:i | self byteAt: i put: (MDArbitrary nextInt: 256) - 1].
	self setCheckByte! !

!MDHashstamp methodsFor: 'testing' stamp: 'cwp 8/8/2009 16:24'!
isValid
	| hash |
	hash := MDPearsonsHash new.
	hash next: 23 putAll: self startingAt: 1.
	^ hash value = self checkByte! !

!MDHashstamp methodsFor: 'serializing' stamp: 'cwp 11/20/2008 19:18'!
mdSerializeWith: aSerializer 
	aSerializer serializeHashstamp: self! !

!MDHashstamp methodsFor: 'printing' stamp: 'cwp 10/2/2008 20:19'!
printFirst: first second: second third: third on: aStream 
	| a b c d |
	a := first bitShift: -2.
	b := ((first bitShift: 4) bitOr: (second bitShift: -4)) bitAnd: 63.
	c := ((second bitShift: 2) bitOr: (third bitShift: -6)) bitAnd: 63.
	d := third bitAnd: 63.
	aStream
		nextPut: (MDCharMap at: a + 1);
		nextPut: (MDCharMap at: b + 1);
		nextPut: (MDCharMap at: c + 1);
		nextPut: (MDCharMap at: d + 1)! !

!MDHashstamp methodsFor: 'printing' stamp: 'cwp 5/22/2008 00:10'!
printOn: aStream
	| bytes |
	bytes := self bytes.
	1 to: 24 by: 3 do: [:i | self 
							printFirst: (bytes at: i) 
							second: (bytes at: i+1)
							third: (bytes at: i+2)
							on: aStream].! !

!MDHashstamp methodsFor: 'private' stamp: 'cwp 5/22/2008 00:10'!
replaceFrom: start to: end with: bytes
	| offset |
	offset := start - 1.
	1 to: (end - offset) do: [:i | self basicAt: offset + i put: (bytes basicAt: i)]! !

!MDHashstamp methodsFor: 'initialize-release' stamp: 'cwp 1/19/2010 21:20'!
setCheckByte
	| hash |
	hash := MDPearsonsHash new.
	hash 
		next: 23
		putAll: self
		startingAt: 1.
	self 
		byteAt: 24
		put: hash value! !

!MDHashstamp methodsFor: 'initialize-release' stamp: 'cwp 1/19/2010 21:25'!
setTag: aByteArray timestamp: aTimestamp 
	self replaceFrom: 1 to: 4 with: aTimestamp.
	self replaceFrom: 5 to: 23 with: aByteArray.
	self setCheckByte! !

!MDHashstamp methodsFor: 'accessing' stamp: 'cwp 8/8/2009 15:11'!
tag
	| bytes |
	bytes := ByteArray new: 19.
	bytes replaceFrom: 1 to: 19 with: self startingAt: 5.
	^ bytes! !

!MDHashstamp methodsFor: 'accessing' stamp: 'cwp 4/18/2005 13:15'!
timestamp
	^ MDTimestamp fromHashstamp: self! !

Magnitude variableByteSubclass: #MDTimestamp
	instanceVariableNames: ''
	classVariableNames: 'MDDay MDHour MDLeapCycle MDMinute MDMonths MDSecond MDYear'
	poolDictionaries: ''
	category: 'MC2-Core-Utilities'!

MDTimestamp class
	instanceVariableNames: 'parts'!

MDTimestamp class
	instanceVariableNames: 'parts'!

!MDTimestamp class methodsFor: 'private' stamp: 'cwp 5/22/2008 00:10'!
compose: units
	| int accumulate |
	parts := units readStream.
	accumulate := [:ea | int := parts next * ea + int].
	int := 0.
	self highConstants do: accumulate.
	(MDMonths first: parts next) do: [:ea | int := ea + int].
	self lowConstants do: accumulate.
	^ int! !

!MDTimestamp class methodsFor: 'accessing' stamp: 'cwp 4/9/2005 05:04'!
epoch
	^ self new! !

!MDTimestamp class methodsFor: 'accessing' stamp: 'cwp 4/9/2005 01:29'!
epochYear
	^ 1980! !

!MDTimestamp class methodsFor: 'instance creation' stamp: 'cwp 5/22/2008 00:10'!
fromHashstamp: hashstamp
	| inst |
	inst := self new.
	1 to: 4 do: [:i | inst byteAt: i put: (hashstamp byteAt: i)].
	^ inst! !

!MDTimestamp class methodsFor: 'instance creation' stamp: 'cwp 5/22/2008 00:10'!
fromInteger: int	
	| ts |
	int > self range ifTrue: [self error: 'Timestamp out of range'].
	ts := self new: 4.
	ts byteAt: 1 put: (int bitShift: -24).
	ts byteAt: 2 put: ((int bitShift: -16) bitAnd: 16rFF).
	ts byteAt: 3 put: ((int bitShift: -8) bitAnd: 16rFF).
	ts byteAt: 4 put: (int bitAnd: 16rFF).
	^ ts! !

!MDTimestamp class methodsFor: 'private' stamp: 'cwp 4/16/2005 16:16'!
highConstants
	^ Array
		with: MDLeapCycle
		with: MDYear! !

!MDTimestamp class methodsFor: 'initializing' stamp: 'cwp 5/22/2008 00:10'!
initialize
	MDSecond := 1.
	MDMinute := 60 * MDSecond.
	MDHour := 60 * MDMinute.
	MDDay := 24 * MDHour.
	MDYear := MDDay * 365.
	MDLeapCycle := MDYear * 4 + MDDay.
	self initializeMonths.
	! !

!MDTimestamp class methodsFor: 'initializing' stamp: 'cwp 5/22/2008 00:10'!
initializeMonths
	MDMonths := #(31 30 31 30 31 31 30 31 30 31 31) collect: [:ea | ea * MDDay].
! !

!MDTimestamp class methodsFor: 'accessing' stamp: 'cwp 4/9/2005 01:40'!
last
	^ self fromInteger: self range! !

!MDTimestamp class methodsFor: 'private' stamp: 'cwp 4/16/2005 16:17'!
lowConstants
	^ Array
		with: MDDay
		with: MDHour
		with: MDMinute
		with: MDSecond! !

!MDTimestamp class methodsFor: 'instance creation' stamp: 'cwp 4/9/2005 05:04'!
new
	^ self new: 4! !

!MDTimestamp class methodsFor: 'instance creation' stamp: 'cwp 5/10/2008 18:40'!
now
	| platform |
	platform := MDPlatform current.
	^ self fromInteger: platform timestampSeconds! !

!MDTimestamp class methodsFor: 'accessing' stamp: 'cwp 4/9/2005 01:43'!
range
	^ 3786825599! !

!MDTimestamp class methodsFor: 'instance creation' stamp: 'cwp 5/22/2008 00:10'!
year: aYear month: aMonth day: day hour: hour minute: minute second: second
	| year month units |
	aMonth < 3 
		ifTrue: [year := aYear - self epochYear - 1. month := aMonth + 10]
		ifFalse: [year := aYear - self epochYear. month := aMonth - 2].
	units := Array new: 7.
	units at: 1 put: year // 4.
	units at: 2 put: year \\ 4.
	units at: 3 put: month - 1.
	units at: 4 put: day - 1.
	units at: 5 put: hour.
	units at: 6 put: minute.
	units at: 7 put: second.
	^ self fromInteger: (self compose: units)! !

!MDTimestamp methodsFor: 'comparing' stamp: 'cwp 9/11/2005 17:25'!
< other
	^ self asInteger < other asInteger! !

!MDTimestamp methodsFor: 'comparing' stamp: 'cwp 9/11/2005 17:25'!
= other
	self class == other class ifFalse: [^ false].
	self byteSize = other byteSize ifFalse: [^ false].
	^ self asInteger = other asInteger! !

!MDTimestamp methodsFor: 'converting' stamp: 'cwp 9/10/2005 23:30'!
asInteger
	| integer |
	integer := 0.
	1 to: self size do: [:i | integer := (integer bitShift: 8) + (self byteAt: i)].
	^ integer! !

!MDTimestamp methodsFor: 'accessing' stamp: 'cwp 4/5/2005 21:19'!
byteAt: index
	^ self basicAt: index! !

!MDTimestamp methodsFor: 'accessing' stamp: 'cwp 4/5/2005 21:20'!
byteAt: index put: byte
	^ self basicAt: index put: byte! !

!MDTimestamp methodsFor: 'accessing' stamp: 'cwp 4/9/2005 04:59'!
byteSize
	^ self basicSize! !

!MDTimestamp methodsFor: 'accessing' stamp: 'cwp 6/18/2005 16:04'!
day
	^ (self decompose at: 4) + 1! !

!MDTimestamp methodsFor: 'private' stamp: 'cwp 5/22/2008 00:10'!
decompose
	| results int reduce |
	results := (Array new: 7) writeStream.
	int := self asInteger.
	reduce := [:unit | results nextPut: int // unit. int := int \\ unit].
	reduce value: MDLeapCycle.
	int := self reduceYearsIn: int on: results.
	int := self reduceMonthsIn: int on: results.
	self lowConstants do: reduce.
	^ results contents! !

!MDTimestamp methodsFor: 'private' stamp: 'cwp 4/9/2005 01:14'!
epochYear
	^ self class epochYear! !

!MDTimestamp methodsFor: 'comparing' stamp: 'cwp 9/11/2005 18:28'!
hash
	^ self asInteger hash! !

!MDTimestamp methodsFor: 'private' stamp: 'cwp 4/16/2005 16:17'!
highConstants
	^ self class highConstants! !

!MDTimestamp methodsFor: 'accessing' stamp: 'cwp 6/18/2005 16:04'!
hour
	^ self decompose at: 5! !

!MDTimestamp methodsFor: 'private' stamp: 'cwp 4/16/2005 16:18'!
lowConstants
	^ self class lowConstants! !

!MDTimestamp methodsFor: 'printing' stamp: 'cwp 11/20/2008 19:18'!
mdSerializeWith: aSerializer 
	aSerializer serializeTimestamp: self! !

!MDTimestamp methodsFor: 'accessing' stamp: 'cwp 6/18/2005 16:04'!
minute
	^ self decompose at: 6! !

!MDTimestamp methodsFor: 'accessing' stamp: 'cwp 4/9/2005 04:27'!
month
	^ self monthFrom: self decompose! !

!MDTimestamp methodsFor: 'private' stamp: 'cwp 6/18/2005 16:04'!
monthFrom: anArray
	^ (anArray at: 3) + 2 \\ 12 + 1! !

!MDTimestamp methodsFor: 'printing' stamp: 'cwp 4/9/2005 02:55'!
printFormat: aString
	^ self printer printFormat: aString! !

!MDTimestamp methodsFor: 'printing' stamp: 'cwp 4/9/2005 04:23'!
printOn: aStream
	self printer printOn: aStream format: '%e %B %Y %i:%M:%S %p' ! !

!MDTimestamp methodsFor: 'printing' stamp: 'cwp 6/18/2005 16:04'!
printer
	| units |
	units := self decompose.
	^ MDTimestampPrinter
		year: (self yearFrom: units)
		month: (self monthFrom: units)
		day: (units at: 4) + 1
		hours: (units at: 5)
		minutes: (units at: 6)
		seconds: (units at: 7)! !

!MDTimestamp methodsFor: 'private' stamp: 'cwp 6/18/2005 16:04'!
reduceMonthsIn: anInteger on: aStream
	| months int |
	months := 0.
	int := anInteger.
	MDMonths do: [:ea | 
				int < ea
					ifTrue: [aStream nextPut: months. ^ int]
					ifFalse: [int := int - ea].
				months := months + 1].
	aStream nextPut: months.
	^ int! !

!MDTimestamp methodsFor: 'private' stamp: 'cwp 8/21/2005 02:37'!
reduceYearsIn: anInteger on: aStream
	| years |
	years := anInteger // MDYear min: 3.
	aStream nextPut: years.
	^ anInteger - (MDYear * years)! !

!MDTimestamp methodsFor: 'accessing' stamp: 'cwp 4/23/2008 07:29'!
second
	^ self decompose at: 7! !

!MDTimestamp methodsFor: 'accessing' stamp: 'cwp 8/9/2005 21:21'!
timestamp
	^ self! !

!MDTimestamp methodsFor: 'accessing' stamp: 'cwp 4/9/2005 04:29'!
year
	^ self yearFrom: self decompose! !

!MDTimestamp methodsFor: 'private' stamp: 'cwp 8/20/2005 21:48'!
yearFrom: anArray
	| years |
	years := anArray first * 4 + (anArray at: 2).
	years := years + self epochYear.
	^ (anArray at: 3) < 10 ifTrue: [years] ifFalse: [years + 1]! !

!Array methodsFor: '*mc2-core-serialization' stamp: 'cwp 11/20/2008 19:18'!
mdSerializeWith: aSerializer 
	self class = Array 
		ifTrue: [ aSerializer serializeArray: self ]
		ifFalse: [ super mdSerializeWith: aSerializer ]! !

GRError subclass: #MDError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Core-Kernel'!

!WideString methodsFor: '*mc2-core-serialization' stamp: 'cwp 11/20/2008 19:18'!
mdSerializeWith: aSerializer 
	aSerializer serializeUtf16String: self! !

!Boolean methodsFor: '*mc2-core-serialization' stamp: 'cwp 11/20/2008 19:18'!
mdSerializeWith: aSerializer 
	aSerializer serializeSingleton: self! !
MDMaterializer initialize!
MDPearsonsHash initialize!
MDTimestampPrinter initialize!
MDHashstamp initialize!
MDTimestamp initialize!
